; GW49_init_ASM on win1_ass_dv1
; and win1_ass
; 19th January 2012
;
; Version 5.07 - 19th January 2012
;	1. Allow JSR,L for absolute <ea>s
;
; Version 5.03 - 8th June 2009
;	1. Check for buffer o/v in EDLIN
;
; Version 4.34 - 5th May 2008
;	1. Increase INSERTS to 12 bytes allowing 4_byte addresses
;
; Version 4.33 - 13th November 2007
;	1. Reset MOVEM.L A7,-(A7) as 68020+ test
;
; Version 4.32 - 29th July 2007
;	1. Corrected INST_ED2 for case of no inserts
;
; Version 4.30 - 21st January 2006
;	1. Need VEC(A6) to store TRAPV for QPC2 test
;
; Version 4.28 - 25th January 2005
;	1. COMPLEX byte set "complex" PCs
;
; Version 4.27 - 20th December 2004
;	1. Set zero bytes for DS instructions and
;	   for aligning on a word boundary.
;
; Version 4.26 - 23rd November 2004
;	1. Allow parameter list entry for QM_PAR
;
; Version 4.24 - 20th October 2004
;	1. Allow Qmac macro parameters with QM_PAR.
;	2. Altered BUF_SIZE from 60 to 124
;
; Version 4.23 - 19th August 2004
;	1. Allow | and ~ to be in parameters by hiding.
;
; Version 4.22 - 13th July 2004
;	1. EQU_INC_S increased for changed EQU lists in GNUM
;
; Version 4.20 started - 25th May 2003
;	1. IF_SW tested in DO_ERR so expunged from MACRO
;
; Version 4.19 started - 13th February 2003
;	1. Correct default 512 in D_ACTION.
;	2. Allow expressions - add EXP_ON/ EXP_OFF
;	3. Set EXP defaults from DEF_EXP
;	4. Set Bcc/BSR.L -> .W if low_ea
;	5. Allow comment lines to start with SPACEs & TABs
;	6. Correct \0 for single digit numbers
;	7. Add label no for MACROs to parameter list
;	8. Correct LEN in macros
;	9. Added space to macro LK
;        10. Added |#REPL(n)~ to macro functions
;        11. Added |#LCASE<str>~ and |#OPTS~
;        12. Correct alteration 5.
;        13. Altered a branch to MACP2_3 to short
;
; Version 4.18 started - 9th October 2002
;	To allow a change of DATAD$ between runs (if PE)
;
; Version 4.17 started - 28th September 2002
;	To add a warning if too few END_IFs
;	To correct FrMOVE
;
; Version 4.16 started - 27th July 2002
;	To correct XDEF/XREF output for long names
;	To set VERSION in a separate file
;	To allow a final, hanging, label to be processed
;
; Version 4.15 started - 11th December 2001
;	To allow a bigger range for DEC (2_asm)
;
; Version 4.14 started -  10th August 2001
;	To allow all characters in a batch file name (except"/")
;
; Version 4.13 started -  6th February 2001
;	To correct MOVEP
;
; Version 4.12 started -  20th January 2001
;	To correct Config Blocks (6_asm)
;	And to set a mode 4 window if not mode 8
; Version 4.11 started -  17th June 2000
; Version 4.10 started -  23rd February 2000
; Sets mode to 8 for mode 8, 0 otherwise
;
; Version 4.9 started - 2nd December 1999
; Correction to LIST/NOLIST (in 1A)
; Allow EQU etc between labels
;
; Version 4.8 started - 18th March 1999
; DCB now allows a string constant
;
; Version 4.7 started - 27th February 1999
; ABS <ea> tidied up
;
; Version 4.6 started - 11th February 1999
; Tidy up closing of erroneous _TMP etc files
;
; Version 4.5 started - 22nd January 1999
; LIST/NOLIST added - Nov 98
; FR for macro added - Dec 98
;
;  An ASSEMBLER program
; for the MC68000 series
;
;  NB This program can only be run
;      on a 68020 or above.
*
	section prog
*
*
*	External symbols to do with the window definition...
*
	xref.w	wwa.gwass,WWB.GWASS
	xref	men_gwass,c.last,wst_gwass
	XREF	MEA_MOVE,NOE1
	XDEF	DV_WWoRK,DV_WMVEC,DV_CHID,STACK,REP3,REGS
	XDEF	OVER,INK,AT
*
HED	MACRO	message,name
\2	DC.W	LE\@-L\@
L\@	DC.B	\1
LE\@	DS.B	0
	ENDM
*
*
* Since GWASS must, perforce, treat PC type xref's as far away
* it means that the PC offset will be taken as greater than a word in length.
* In practice this will only happen with large programs. To produce an offset
* that can be run on a 68000 we do the following:
*
*  Define a constant to be the difference between the PC of the instruction
*  needing the xref and the xref PC itself. This is now a scalar or absolute
*  number which can be defined to be a word (or even a byte!). If in practice
*  the offset is too big the LINKER should signal an error or issue a warning.
*  Now use the constant as the required offset.
*
*  For example:
*
*	XREF	MEN_TEST
* K	DC.W	MEN_TEST-K
*	LEA	K,A0
*	ADDA.W	K,A0
*
*
	ERR
	DATA	22000
;
LK	MACRO	number of items
L\@	SET	0
	MACL	HERE
	IF	L\@ <= \1
	 IF	 L\@ = 0
	  LINK.W	  A6,#-8
	 ELSE_IF	 L\@ < 4
	  LINK.W	  A6,#-134 * Altered 31/10/04 from 70 *
	 ELSE
	  LINK.W	  A6,#-PAR_SZE-2*L\@-8 * Altered 5/4/03 *
	 ENDIF
	 BRA.W	 PR31_1
L\@	 SET	 L\@+1
	 GOTO	 HERE
	ENDIF
	ENDM
;
MSG	MACRO
\4\1	DC.W	\4\1E-\4\1-2
	DC.B	\2\3	(allow up to 64 characters)
\4\1E	DS.B	0
	ENDM
;
G_LST	MACRO	list name, prog, start number,how many
L\@	SET	\3
\1
	MACL	HERE
	IF	L\@ <= \4
	DC.W	\2|L\@~-\1
L\@	SET	L\@+1
	GOTO	HERE
	ENDIF
	ENDM
;
EXTU	MACRO
	IF	1+\4-\3>30
	\5	\1,\2,\3,|\3+30~
	EXTU	\1,\2,|\3+31~,\4,\5
	ELSE
	\5	\1,\2,\3,\4
	ENDIF
	ENDM
;
ext1	macro
	if	\3<=\4
	dc.w	\1\3-\2
	ext1	\1,\2,|\3+1~,\4
	endif
	endm
;
INK	MACRO	COLOR
	MOVEQ	#\1,D1
	BSR	INK
	ENDM
;
AT	MACRO	X_POS,Y_POS
	MOVEQ	#\1,D1
	MOVEQ	#\2,D2
	BSR	AT
	ENDM
;
CLS_BOT MACRO
	MOVEQ	#SD_CLRBT,D0
	TRAP	#3
	MOVEQ	#SD_CLRLN,D0
	TRAP	#3
	ENDM
;
TITLE	EQU	?"GW49"
STK_SIZE	EQU	322	20 parameters 2|14 + word no of pars
VAL	EQU	2
TYPE	EQU	6
	IN	@TITLE,"_VER_ASM"
VNUM	EQU	?"60"
NO_SEPS	EQU	14	No of separator tests
;
O_BUF_SZE EQU	100

	RSSET	0
EQB	RS.L	1	**************************
EQU_LEN	RS.L	1	*     Dynamic Storage    *
EQU_INC	RS.L	1	*		     *
CH_LST	RS.L	1	*    Space is allotted   *
CH_LENG	RS.L	1	*   in blocks of length  *
CH_INC	RS.L	1	*	x_INC + 1      *
CHM_LST	RS.L	1	*		     *
CHM_LEN	RS.L	1	*   The space allotted   *
CHM_INC	RS.L	1	*  at any time is given  *
IF_ON	RS.L	1	*	in x_LEN	     *
IF_LEN	RS.L	1	*		     *
IF_INC	RS.L	1	* When space is allotted *
XREF_IX	RS.L	1	*  the old contents are  *
IX_LEN	RS.L	1	*  copied to it possibly *
IX_INC	RS.L	1	*    with 'relocation'   *
XREF_LST	RS.L	1	* (See EXTENS in 5_ASM)  *
XLST_LEN	RS.L	1	*		     *
XLST_INC	RS.L	1	**************************
CPC_LST	RS.L	1 Space for PCs . .
CPC_LEN	RS.L	1 . . during . .
CPC_INC	RS.L	1 . . compression
BINS	RS.L	1 current chunk
BIN_F	RS.L	1 1st chunk
BIN_L	RS.L	1 last chunk
PRL	RS.L	1 Address of LIST/NOLIST chunk
PRL_N	RS.L	1 Pointer to next LIST/NOLIST line
;
; ********************************************************
; * A chain of chunks PRL_INC_S long contains a list     *
; * of the line numbers of the commands LIST and NOLIST  *
; *					       *
; * A chunk is:				       *
; *   _________________________________________________  *
; *  | Ptr to next chunk | Ptr to next space | Line no . *
; *					       *
; * When LIST/NOLIST first appears the chain is set up   *
; * with PRL pointing to its start. The last chunk in    *
; * the chain has a zero pointer to the next chunk.      *
; * A positive 'Line no' means LIST, a negative NOLIST.  *
; *					       *
; * During PASS2 if by then bit 5 of DIP is zero this    *
; * bit is set according to the information in the LIST/ *
; * NOLIST chunks. During this PRL is set to point to    *
; * the start of the current chunk and PRL_N to the next *
; * 'Line no'. At any time a zero PRL implies no more    *
; * LIST/NOLIST operations.			       *
; ********************************************************
BLSTCK	EQU	EQB
ER_LST	RS.L	1
TER_LST	RS.L	1
BLLAB	RS.L	1
LINE_NO	RS.L	1
BLLAB1	RS.L	1
BLLAB2	RS.L	1	end of ptr space
DV_WWORK	RS.L	1
DV_WMVEC	RS.L	1
REGS	RS.L	2	for A1/A3 during WM.RPTR
STACK	RS.L	1
BIN_BUF	RS.L	1
TMP_BUF	RS.L	1
MOD_NME	RS.B	42
PROMPT	RS.W	1
FILE	RS.B	40
OBUF	RS.L	6
O_BUF	RS.L	O_BUF_SZE+1
BUF	RS.W	129
LBUF	RS.L	64
EX_BUF	RS.W	129	for MACRO functions (#LEN etc)
CO_SE	RS.B	32*8	one byte for each SECTION (0='S' 1='C' 2='O')
ID_CON	RS.L	1
CH_IN	RS.L	1	Start of Temporary Buffer
CH_OUT	RS.L	1
CH_PRNT	RS.L	1
CH_TMP	RS.L	1
CH_SYM	RS.L	1
CH_OUT1	RS.L	1
CH_NO	RS.W	1
CHM_NO	RS.W	1
PCK	RS.W	1
PWID	RS.W	1
FLTYP	RS.W	1	allows choice of file type
MAC_NO	RS.W	1
XREF_NO	RS.W	1
SEC_NO	RS.W	1
MAC_CT	RS.W	1
MAC_LST	RS.L	3
SEC_LST	RS.L	3
LAB_LST	RS.L	3
MINN	RS.L	3     "     three info. chunks
SINN	RS.L	3     "     three     "
LINN	RS.L	4     "     four      "
SL1	RS.W	1  label no after EQU_SYM in 1st strand
SL2	RS.W	1      "         "		 2nd   "
SL3	RS.W	1      "         "		 3rd   "
SEC_PC	RS.L	256
BIN_LINE	RS.L	1   address of allocation in user heap
COMP_MARK RS.W	1
MAC_BUF	RS.L	64
P_MAC	RS.L	1	pointer to chain of addesses for 'P' file info
BIN_IN	RS.L	1
BIN_OUT	RS.L	1
HEAPAD	RS.L	1
DPCW	RS.L	1
DATA	RS.L	1
ER_SPACE	RS.L	3004	space for errors | KEEP THESE |
CRT_SEC	RS.W	1		       | TOGETHER	|
PC_TOT	RS.L	1      End of Temporary Buffer
PC_INST	RS.L	1
SIZE	RS.W	1
MARK	RS.W	2
EXTBUF	RS.W	7
TMP_NME	RS.L	10
BIN_NME	RS.L	10
REL_NME	RS.L	10
ITEM	RS.L	1
EA_INSMK	RS.L	1
EA_INSMK1 RS.L	1
IF_LNO	RS.L	1
B_FLS	RS.L	1
BF_ADDR	RS.L	1
EA_STK	RS.L	3
;	4 bytes here for -1 entry to PCW
PCW	RS.L	64
SEC_EQLST RS.L	64	to allow 256 sections
TK2_BUFFER	RS.B	58 to allow paths to filenames
DATAD	RS.B	58	space for DATAD$
PROGD	RS.B	58	space for PROGD$
VEC	RS.L	19	space for TRAPV (if needed)
RS	RS.L	1
G_LIMIT	RS.L	1   lowest STACK address for GLABx
PC_TH	RS.L	1   address of current 6-byte PC list entry
PC_PR	RS.L	1     "        previous  "	     "
PC_CS	RS.L	1     "        start of current PC chunk
PC_CS1	RS.L	1     "        start of 1st PC chunk
X_ALLOC1	RS.L	1     "        ALCHP chain
TEMR_L	RS.L	1   For errors in PASS2 - space ALLOC'd then
NO_ERRS	RS.L	1
NO_WARNS	RS.L	1
PC_NOW	RS.L	1
QTAB	RS.L	$30	for Qmac macros -> GWASS
IF_L	RS.W	1
ACT_L	RS.W	1
E_COM	RS.W	1
K_MARK	RS.L	1	Used in EQU etc . .
K_VAL	RS.L	1	. . to allow a preceding . .
K_TYP	RS.W	1	. . label to equal a following one
CPC	EQU	IF_L
TOT_BERRS RS.L	1   ***************************
DEFAULT	RS.W	1   *	     DIP		*
BIN_SWTCH RS.B	1   * Bit  On	 Off	*
CMP_TYPE	RS.B	1   *			*
REL_SWTCH RS.B	1   *  0	 CASE_DIFF CASE_IND *
DIP	RS.B	1   *  4	 LOW_EA	 HIGH_EA	*
F_EA	RS.B	1   *  5	 ERR	 LST	*
ER_EA	RS.B	1   *  6	 EXP_ON	 EXP_OFF	*
;		    *  7	 QM_PAR	 GW_PAR	*
B_CNST	RS.B	1   * Bits 1-3  Meaning	*
BATCH	RS.B	1   *  0	      68040	*
PTR_ON	RS.B	1   *  1	      68030	*
;		    *  2	      68EC030	*
IF_SW	RS.B	1   *  3	      68851	*
TEMP_ON	RS.B	1   ***************************
BF	RS.B	1	set 1 for later BATCH
MODE	RS.B	1	set to 0/8 (or 33 for Q40 sometimes!)
ORG_H	RS.B	1	1=ORG 0=no ORG
SBT1	RS.B	1	substitute for |
SBT2	RS.B	1	substitute for ~
COMPLEX	RS.B	1	1 = compression suppressed
J_SIZE	RS.B	1	1 = .L for absolute <ea> [for JSR/JMP]
;
DEND	EQU	ORG_H+1 end of DATA SPACE
TEMP_BUF	EQU	CH_IN	(up to 4742 bytes @ start)
O_BEND	EQU	BUF
TMACLST	EQU	MAC_BUF
T_BUFSIZE EQU	4740
HEAP_SIZE EQU	$15000
MAX_FLES	EQU	677
MAX_SEC	EQU	256
MAX_EQU	EQU	$B000	largest allowable EQU_SYM file
MAX_D	EQU	4095	maximum defaults which can be set
;MAX_STL	 EQU	 38	 maximum string length for config/config2
B_BUFSZE	EQU	506
T_BUFSZE	EQU	502
EQU_INC_S EQU	64-1	(was 16-1)
BIN_INC_S EQU	$FFC	340*12 + 12      (was 406*10+12)
CPC_INC_S EQU	127

; BINS are chained
;     ____________________________________________________
;    | pointer  | pointer | pointer |< INS >< INS > ..    |
;    	      	      			
;    |	      |	      to first free space ___/
;    |	      to previous chunk (or 0)
;    to next chunk (or 0)
;
CH_INC_S	EQU	64*4-1
CHM_INC_S EQU	64*4-1
IF_INC_S	EQU	$100-1
IX_INC_S	EQU	8-1
XLST_INC_S	EQU	32-1
PRL_INC_S EQU	128
HEAP_SPACE	EQU	$4C000
PC_SZE	EQU	1024*6+4
ALC_MAX	EQU	$8000
ALC_MIN	EQU	$2000

;
BUF_SIZE	EQU	124	was 60 - 31st October 2004
CHLEN	EQU	512
LLEN	EQU	520
SEC	EQU	10	section value at end of INS (was 8)	NEW
CI_SZE	EQU	$4000
LN1	EQU	12	single length of packed mantissa
LN2	EQU	24	double length of packed mantissa
N1	EQU	12	relative place in BUF for numbers
N2	EQU	N1+LN1		    "
N3	EQU	N2+LN1		    "
PAR_SZE	EQU	32	max parameter size for macros
;
	BRA.S	START
	DS.L	1
	DC.W	$4AFB
	HED	<"GWASS",VNUM," V",VERSION>

AD_QR32	DC.L	QER32-*		If not 68020+

QR32	LEA	AD_QR32,A2
	ADDA.L	(A2),A2
	JMP	(A2)
;
START	LEA	(A6,A5.L),A0	STACK
	LEA	(A6,A4.L),A6	-> DATA SPACE
	MOVE.L	A0,STACK(A6)
	MOVE.L	#-1,NO_ERRS(A6)	inhibit error printing 1st time
	CLR.L	LINE_NO(A6)	in case of FATAL ERROR
	ST	DV_WMVEC(A6)	set 'no ptr' for the noo
	MOVE.W	(A7)+,D1
	MOVEA.L	A7,A4		-> STRING?
	SUBQ.W	#1,D1
	BMI	NO_CHAN
	MOVE.B	#-2,DV_WMVEC(A6)	set 'no ptr' ever
	LSL.W	#2,D1
	MOVEA.L	(A7,D1.W),A0	CH_ID
	LEA	4(A7,D1.W),A4	-> STRING
	BRA.S	NOTE_CHAN
NO_CHAN	MOVEQ	#-1,D1
	MOVEQ	#-1,D2
	MOVE.L	A4,-(A7)		keep A4
	MOVEQ	#MT_DMODE,D0
	TRAP	#1		ask for mode
	MOVEA.L	(A7)+,A4		restore A4
	MOVE.B	D1,MODE(A6)	Under Q40 SMSQE it could be 33
	LEA	CON1,A0		window for mode 4
	CMP.B	#8,D1
	BNE	NO_CHAN1
	LEA	CON2,A0		window for mode 8
NO_CHAN1	MOVEQ	#0,D3
	MOVEQ	#-1,D1		this job
	MOVEQ	#IO_OPEN,D0
	TRAP	#2
NOTE_CHAN MOVE.L	A0,ID_CON(A6)
	CLR.B	BATCH(A6)

	IF 0=1

	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVE.B	$A7(A0),D0
	ANDI.B	#$1E,D0
	CMPI.B	#$1E,D0		QPC? . .
	BNE	NOT_QPC
	LEA	VERR1,A0
	MOVEQ	#18,D0
	LEA	VEC(A6),A1         for TRAPV table
QPC1	MOVE.L	A0,(A1)+
	DBF	D0,QPC1
	LEA	VERR,A0
	MOVE.L	A0,VEC+4(A6)
	LEA	VEC(A6),A1
	MOVEQ	#-1,D1
	MOVEQ	#MT_TRAPV,D0
	TRAP	#1
	BFTST	D0{1:1}             to see if QPC 68020+
	MOVE.L	VEC(A6),VEC+4(A6)	stop illegal routine
	BRA	QPC2

VERR	MOVE.L	A0,-(A7)		Illegal exception routine
	LEA	QR32,A0
	MOVE.L	A0,6(A7)
	MOVEA.L	(A7)+,A0
VERR1	RTE

	ENDIF



	MOVEM.L	A7,-(A7)		to test if 68020+
	CMPA.L	(A7),A7		equal if OK
	ADDQ.L	#4,A7		restore stack
	BNE	QR32	         ---->
	MOVEQ	#0,D0		set both DATAD & PROGD
	BSR	SET_DP
	MOVE.W	#$100,D1
	TST.B	DEF_CD
	BEQ	SDEF
	BSET	#0,D1
SDEF	MOVE.B	DEF_68,D0
	BFINS	D0,D1{28:3}
	TST.B	DEF_EA
	BEQ	SDEF_1
	BSET	#4,D1
SDEF_1	TST.B	DEF_EL
	BEQ	SDEF_2
	BSET	#5,D1
SDEF_2	TST.B	DEF_UX
	BEQ	SDEF_3
	BSET	#9,D1
SDEF_3	TST.B	DEF_PC
	BEQ	SDEF_4
	BSET	#10,D1
SDEF_4	TST.B	DEF_REL
	BEQ	SDEF_5
	BSET	#11,D1
SDEF_5	TST.B	DEF_COM
	BEQ	SDEF_6
	BSET	#12,D1
SDEF_6	TST.B	DEF_EXP
	BEQ	SDEF_7
	BSET	#6,D1
SDEF_7	TST.B	DEF_PAR
	BEQ	SDEF_8
	BSET	#7,D1
SDEF_8	MOVE.W	D1,DEFAULT(A6)	set defaults
	MOVE.B	DEF_SB1,D5
	SUB.B	DEF_SB2,D5
	BEQ	QER36	---->	the defaults must differ!
	MOVE.W	DEF_SB1,SBT1(A6)	set substitute defaults for | ~
	CLR.B	PTR_ON(A6)	mark ptr not started
	MOVEQ	#0,D5		mark 'default _SYM'
	MOVE.W	(A4)+,D6		string length
	BEQ	START8		not batch or alt _SYM file
	MOVE.B	#-2,DV_WMVEC(A6)	mark 'no ptr'
	LEA	TEMP_BUF(A6),A3
	CMPI.W	#PC_TOT-CH_IN-20,D6
	BGT	QER18	---->	string too long (>1408 bytes)
	MOVE.W	D6,D0
	SUBQ.W	#1,D0
	LSR.W	#1,D0		round down to words
START4	MOVE.W	(A4)+,(A3)+
	DBF	D0,START4 	put string to TEMP_BUF
	MOVE.B	#'/',TEMP_BUF(A6,D6.W)	 mark end
	MOVE.B	#'*',TEMP_BUF+1(A6,D6.W) of string
	MOVEA.L	STACK(A6),A7	set stack and overwrite string
	LEA	TEMP_BUF(A6),A4	-> start
	CLR.B	PC_TOT(A6)	space to note ACTIONS
START12	MOVE.B	(A4)+,D0		1st character
	CMPI.B	#$29,D0
	BLS	QER19	---->
	CMPI.B	#$7A,D0 'z'
	BHI	QER19	---->
	CMPI.B	#"*",D0
	BEQ	START8		end
	CMPI.B	#'Z',D0
	BLS	START5
	SUBI.B	#32,D0		to upper case
START5	CMPI.B	#"A",D0
	BEQ	A_ACTION		list of _ASM files
	CMPI.B	#"D",D0
	BEQ	D_ACTION
	CMPI.B	#"Q",D0
	BEQ	Q_ACTION
	CMPI.B	#"S",D0
	BNE	QER19	---->	FATAL
;
; S_action - set substitutes for "|" and "~"
; These must be between ASCII 128 and 191 inclusive
; and must not be the same!
;
	BSET	#3,PC_TOT(A6)
	BNE	QER29	---->
	MOVEA.L	A4,A1
	CMPI.B	#'/',(A1)+
	BNE	QER29	---->
	BSR	STRG		read the two characters
	BMI	QER29	---->
	SUBQ.W	#2,(A2)+
	BNE	QER29	---->	must be just 2 characters
	MOVEQ	#1,D1		set count for 2
S_ACTION1 MOVE.B	(A2)+,D0		read character
	CMPI.B	#128,D0
	BLO	QER29	---->
	CMPI.B	#191,D0
	BHI	QER29	---->
	DBF	D1,S_ACTION1
	CMP.B	-2(A2),D0 	compare 1st and 2nd
	BEQ	QER29	---->
	MOVE.W	-2(A2),SBT1(A6)	set the characters
	BRA	Q_ACTION3
;
; Q_action - set EQU_SYM filename
;
Q_ACTION	BSET	#0,PC_TOT(A6)	mark Q_ACTION
	BNE	QER29	---->
	MOVEA.L	A4,A1
Q_ACTION1 CMPI.B	#'/',(A1)+,	check for '/'
	BNE	QER29	---->	FATAL
	BSR	STRG
	BMI	QER29	---->	FATAL
	LEA	O_BUF(A6),A0	space for filename
	MOVE.L	A0,D5		and keep address in D5
	MOVE.W	(A2),D1		string length
	CMPI.W	#126,D1		a longer length is likely an error
	BGT	QER20	---->	FATAL
	ADDQ.W	#1,D1
	LSR.W	#1,D1		round to higher word
Q_ACTION2 MOVE.W	(A2)+,(A0)+	put to O_BUF
	DBF	D1,Q_ACTION2
Q_ACTION3 MOVEA.L	A1,A4
	BRA	START12
;
A_ACTION	BSET	#2,PC_TOT(A6)	mark A_ACTION
	BNE	QER19	---->
	ST	BATCH(A6) 	mark batch
	CLR.L	TOT_BERRS(A6)	clear total errors
	MOVEA.L	A4,A1
	CMPI.B	#"/",(A1)+
	BNE	QER19	---->	FATAL
	MOVE.L	D5,D2		keep D5
	MOVE.B	(A1)+,D0
	BSR	DEC		to get no. of files
	BNE	QER19	---->	FATAL
	EXG	D5,D2
	CMPI.L	#MAX_FLES,D2
	BGT	QER21	---->	FATAL
	TST.L	D2
	BEQ	QER22	---->	FATAL
	CMPI.B	#'/',D0
	BNE	QER23	---->	FATAL
	MOVE.W	D2,D7
	MOVEA.L	A1,A4
	MOVE.L	D2,D1
	ADD.L	D1,D1
	EXT.L	D6
	ADD.L	D6,D1		len + 2*n
	ADDQ.L	#4,D1		for safety
	MOVEQ	#-1,D2		this job
	MOVEQ	#MT_ALCHP,D0
	TRAP	#1		get space
	TST.L	D0
	BNE	QER4	---->	FATAL
	MOVE.L	A0,BF_ADDR(A6)	file list address
	MOVEA.L	A4,A1		restore A1
	BRA	A_ACTION1
A_ACTION4 BSR	STRGB		get next file
	BMI	QER19	---->	FATAL
	CMPI.B	#'/',D0
	BNE	QER23	---->	FATAL
	TST.W	D2		count
	BEQ	A_ACTION1 	no file!!
	ADDQ.W	#1,D2
	LSR.W	#1,D2		round to higher word
A_ACTION3 MOVE.W	(A2)+,(A0)+	filename to BF_ADDR
	DBF	D2,A_ACTION3
A_ACTION1 DBF	D7,A_ACTION4	count files
	CLR.W	(A0)		mark end of files
	MOVE.L	BF_ADDR(A6),B_FLS(A6) point to 1st file
	BRA	Q_ACTION3
;
D_ACTION	BSET	#1,PC_TOT(A6)
	BNE	QER30	---->
	MOVEA.L	A4,A1
	CMPI.B	#'/',(A1)+
	BNE	QER30	---->
	MOVE.L	D5,D2
	MOVE.B	(A1)+,D0
	BSR	DEC
	BNE	QER30	---->
	EXG	D5,D2
	CMPI.L	#MAX_D,D2
	BGT	QER30	---->
	CMPI.B	#'/',D0
	BNE	QER31	---->
	CLR.W	DEFAULT(A6)
	BSET	#0,D2
	BEQ.S	D_ACTION1
	BSET	#0,DEFAULT+1(A6)
D_ACTION1 BFINS	D2,DEFAULT(A6){5:3}
	LSR.W	#3,D2
	BFINS	D2,DEFAULT+1(A6){2:5}
	LSR.W	#5,D2
	BFINS	D2,DEFAULT(A6){3:2}
	LSR.W	#2,D2
	BFINS	D2,DEFAULT+1(A6){0:2}
	BRA	Q_ACTION3
;
CON	DC.B	230,2	border
	DC.B	BLACK,GREEN	paper/ink
	DC.W	340,84,100,50
;
	HED	<'CON_340X84A100X50'>,CON1
	HED	<'CON_512X84A0X50'>,CON2
;
SRT	DC.L	UMT1-SRT	to allow 16-bit jumps ...
	DC.L	INK-SRT ... to UMT1 & INK
;
; QTB gives the ASCII number for a character followed by its program
; number. (See PR31)
;
QTB	DC.B	9,1,$A,2,$20,1,$2C,3,$3B,$D,$3C,$C,$3E,7,$5C,6,$7B,4
	DC.B	$7C,8,$7D,5,$7E,9,0
;
; Set the Qmac program number table for Qmac pars -> GWASS
;
START8	MOVE.W	#$2F,D0		count of 4*table space - 1
	LEA	QTAB(A6),A0	address of table -> A0
START1	CLR.L	(A0)+		clear the . .
	DBF	D0,START1 	. . table
	MOVEQ	#0,D0
	LEA	QTB,A0
START2	MOVE.B	(A0)+,D0
	BEQ	START6
	MOVE.B	(A0)+,QTAB(A6,D0.W)
	BRA	START2
START6	MOVE.B	SBT1(A6),D0
	MOVE.B	#$A,QTAB(A6,D0.W)
	MOVE.B	SBT2(A6),D0
	MOVE.B	#$B,QTAB(A6,D0.W)
	MOVEA.L	STACK(A6),A7	set stack and overwrite string
	MOVE.L	#HEAP_SPACE,D1
	MOVEQ	#-1,D2		this JOB
	MOVEQ	#MT_ALCHP,D0
	TRAP	#1
	TST.L	D0
	BNE	QER4	----> FATAL ERROR!!
	MOVE.L	A0,BLLAB(A6)
	MOVE.W	#128,LBUF-2(A6) shows "\" in a MACRO line
	LEA	ER_SPACE(A6),A0
	MOVE.L	A0,ER_LST(A6)
	LEA	CRT_SEC(A6),A0
	MOVE.L	A0,TER_LST(A6)
	CLR.W	COMP_MARK(A6)
	CLR.B	F_EA(A6)
	CLR.B	BF(A6)
	MOVE.L	#$10000,ITEM(A6)
	PEA	FILEDEV
	PEA	PROMPT(A6)
	BSR	QSTRCPY
	ADDQ.L	#8,A7
;
;  Loads EQU3_SYM
;    to BLLAB
;
; (A null filename is treated as a zero file)
;
	MOVEQ	#-1,D1		this JOB
	MOVEQ	#0,D3
	TST.L	D5
	BEQ.S	START3		default
	LEA	O_BUF(A6),A0	set input filename
	BRA.S	START10
START3	LEA	EQU_SYM,A0
START10	MOVE.L	BLLAB(A6),BLLAB1(A6) set zero EQU_SYM
	MOVE.L	#1,SL1(A6)
	MOVE.W	#2,SL1+4(A6)
	TST.W	(A0)
	BEQ	START13
	BSR	OPENFILE
	BNE	QER13	---->	FATAL ERROR!!
	MOVEQ	#64,D2
	MOVEQ	#-1,D3
	MOVEA.L	BLLAB(A6),A1
	MOVEA.L	A1,A2
	MOVEQ	#FS_HEADR,D0
	TRAP	#3
	TST.L	D0
	BNE	QER2	---->	FATAL ERROR!!
	MOVE.L	(A2),D4		file length
	BEQ	START9		no file
	CMPI.L	#MAX_EQU,D4
	BGE	QER25	---->
	MOVEQ	#$3E,D2
	CMP.L	D2,D4
	BLT	QER25	---->
	LEA	BUF(A6),A1
	MOVEQ	#IO_FSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QER3	---->	FATAL ERROR!!
	MOVE.L	D2,D0
	MOVEQ	#11,D1	count
	LEA	$C+BUF(A6),A1
START11	ADD.L	(A1)+,D0
	DBF	D1,START11
	CMP.L	D0,D4
	BNE	QER25	---->
	MOVEQ	#2,D0
EQU_IN1	CMP.W	BUF(A6,D0.W*2),D0
	BNE	QER3A	---->
	CMPI.W	#8,6+BUF(A6,D0.W*2)
	BGT	QER3A	---->	must be start or none
	DBF	D0,EQU_IN1
	MOVEA.L	BLLAB(A6),A1	start of input
	LEA	$C+BUF(A6),A3
	MOVE.L	#$30000,$40+BUF(A6) set up 'odd' name
	MOVEQ	#3,D4
EQU_IN2	SWAP	D4
	MOVE.W	#2,D4
EQU_IN3	MOVE.L	(A3)+,D2
	BEQ	EQU_IN4 no chunks
	PEA	EQU_IN4
	MOVE.W	D4,D0
	LSL.W	#2,D0
	NEG.W	D0
	SWAP	D4
	ADD.W	EQ_TAB(D4.W*2),D0
	SWAP	D4
	MOVE.L	A1,(A6,D0.W)	set 1st address of strand
	BTST	#16,D4
	BEQ	EQU_SL
	BRA	EQU_SN
;
EQ_TAB	DC.W	LINN+8
	DC.W	LAB_LST+8
	DC.W	SINN+8
	DC.W	SEC_LST+8
;
EQU_IN4	DBF	D4,EQU_IN3
	SWAP	D4
	DBF	D4,EQU_IN2
	MOVE.W	$3C+BUF(A6),D0	next section no
	MOVE.W	D0,SEC_NO(A6)
	SUBQ.W	#1,D0
	MOVE.W	D0,CRT_SEC(A6)
	MOVEA.L	A1,A2		set BLLAB1 for HEAP start
START9	MOVE.L	A2,BLLAB1(A6)
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
START13	CLR.W	PROGD(A6) 	we don't want this any more
	MOVE.L	BLLAB1(A6),BLLAB2(A6)	allow for no ptr
	LEA	DEND(A6),A0	end of data space
	ADDA.W	#256,A0
	MOVE.L	A0,G_LIMIT(A6)	lowest value of STACK for GLABx
;
; Clear MAC_LST, SEC_LST, MINN, SINN and LINN (4th)
; Clear LAB_LST & LINN from SLi

;
; If not BATCH: set paper black and ink green
;
	TST.B	BATCH(A6) 	BATCH? . . .
	BNE	GWAG		. . . yes
;
; Test if ptr wanted and possible. If so
; get space for status and working window
; and set it up.
;
; DV_WMVEC is -2 if channels or a parameter string have occurred
; else it is -1 at this stage
;
	MOVE.B	DV_WMVEC(A6),D0
	ADD.B	DEF_PTR,D0
	BNE	PTR_NO
	MOVEA.L	ID_CON(A6),A0
	MOVEQ	#$70,D0
	MOVEQ	#-1,D3		timeout
	TRAP	#3
	TST.L	D0
	BEQ	PTR_YES
	ST	DV_WMVEC(A6)
	BRA	PTR_NO
;
PTR_YES	MOVE.L	A1,DV_WMVEC(A6)
	MOVE.L	BLLAB1(A6),A4
	MOVE.L	A4,DV_WWORK(A6)
	LEA	DIFF,A3
	ADDA.L	DIFF,A3		MEN_GWASS
	MOVEQ	#0,D1		default size
	CMPI.B	#8,MODE(A6)
	BEQ	PTR_YES1		mode 8
	MOVE.L	CON+4,D1		minimum size
PTR_YES1	MOVEA.L	A1,A2
	JSR	WM.FSIZE(A2)
	MOVEA.L	A4,A1
	ADDA.L	LSZ(D2.W*4),A1	-> status area
	MOVEA.L	A1,A0
	ADDA.W	W_LEN,A0
	MOVE.L	A0,BLLAB2(A6)
	MOVEA.L	ID_CON(A6),A0
	JSR	WM.SETUP(A2)	set up working window
	movea.l	ww_plitm(a4),a0
	move.l	#6,wwl_pobj(a0)	'move' sprite
	movea.l	($64,a4),a0	info subwindow
	lea	head0_c,a1	address of heading
	move.l	a1,([$10,a0],$e)	put it in the object pointer
*
	MOVEQ	#-1,D1
	JSR	WM.PRPOS(A2)
	JSR	WM.WDRAW(A2)
	BRA	GWAG
;
RPTR	TST.L	NO_ERRS(A6)
	BMI	RPTR1
	AT	0,5
	CLS_BOT
	BSR	GWAG_NOR1
RPTR1	TST.B	PTR_ON(A6)
	BNE	RPTR3		end of 'action'
	ST	PTR_ON(A6)	mark ptr begun
	MOVEA.L	DV_WMVEC(A6),A2
	MOVEA.L	(A4),A1		status area in A1
RPTR2	JSR	WM.RPTR(A2)
	BNE	DSI_KILL
	BTST	#PT..CAN,WSP_WEVE(A1)
	BNE	DSI_KILL
	BTST	#PT..MOVE,WSP_WEVE(A1)
	BEQ	RPTR2
	PEA	RPTR2
	BRA	MEA_MOVE
dsi_kill
	move.l	d0,d3		; this was the error
	BRA	QUIT2
*
RPTR3	MOVEQ	#1,D1
	BSR	OVER
	MOVEM.L	REGS(A6),A1/A3	replace ptrs to status & loose item
	MOVEA.L	DV_WMVEC(A6),A2	replace vector address . .
	MOVEA.L	DV_WWORK(A6),A4	. . and the working definition
	BRA	NOE1
*
LSZ	DC.L	WWA.GWASS 	size of working area
	DC.L	WWB.GWASS
DIFF	DC.L	MEN_GWASS-DIFF
W_LEN	DC.W	C.LAST-WST_GWASS
*
PTR_NO	MOVEA.L	ID_CON(A6),A0
	MOVEQ	#BLACK,D1
	MOVEQ	#SD_SETPA,D0
	TRAP	#3
	MOVEQ	#SD_SETST,D0
	TRAP	#3
	MOVEQ	#GREEN,D1
	BSR	INK
;
; ptr action comes in here
;
GWAG	MOVEQ	#22,D0
	LEA	EQB(A6),A0
GWAG0	CLR.L	(A0)+
	DBF	D0,GWAG0
	MOVEQ	#63,D0
	LEA	CO_SE(A6),A0
GWAG11	CLR.L	(A0)+		Clear CO_SE to 'SECTION'
	DBF	D0,GWAG11
	MOVE.L	#EQU_INC_S,EQU_INC(A6)
	MOVE.L	#CH_INC_S,CH_INC(A6)
	MOVE.L	#CHM_INC_S,CHM_INC(A6)
	MOVE.L	#IF_INC_S,IF_INC(A6)
	MOVE.L	#IX_INC_S,IX_INC(A6)
	MOVE.L	#XLST_INC_S,XLST_INC(A6)
	MOVE.L	#CPC_INC_S,CPC_INC(A6)
	CLR.L	PC_CS1(A6)
	CLR.L	X_ALLOC1(A6)
	CLR.L	PC_CS(A6)
	CLR.B	ORG_H(A6) 	set 'no ORG'
	MOVE.L	#-1,PC_TH(A6)
	MOVEQ	#2,D4		strand count
S_LST	CLR.L	MAC_LST(A6,D4.W*4)
	CLR.L	SEC_LST(A6,D4.W*4)
	CLR.L	MINN(A6,D4.W*4)
	CLR.L	SINN(A6,D4.W*4)
	MOVE.W	SL1(A6,D4.W*2),D3	1st label no after EQU
	BFEXTU	D3{16:14},D1        number inside strand
	BEQ	S_LST1		no EQU in this strand
	BSR	GNL		A2 -> LAB name, A0 -> start of chunk
	BMI	S_LST2		nothing to do
	MOVE.L	A2,(A0)		mark SLi as last name
	CLR.L	4(A0)		see that there are no more chunks
	MOVE.W	D3,D1
	BSR	CHK_L		A0 -> item in LINN
	BEQ.S	S_LST2		no LINN
	BFEXTU	D1{24:6},D0         offset/8 for that item
	NEG.W	D0
	CLR.L	-8(A0,D0.W*8)	make chunk the last one
	MOVE.W	#-2,(A0)		clear that item
S_LST2	DBF	D4,S_LST
	CLR.L	LINN+12(A6)	dummy label area
	CLR.W	SEC_NO(A6)	clear sections
	MOVEA.L	BLLAB2(A6),A0
	MOVE.L	BLLAB(A6),D1
	SUB.L	A0,D1
	ADDI.L	#HEAP_SPACE-16,D1
	MOVE.L	D1,D2
	LSR.L	#2,D2
	BRA	HEAP1
;
S_LST1	CLR.L	LAB_LST(A6,D4.W*4)
	CLR.L	LINN(A6,D4.W*4)
	BRA	S_LST2
;
HEAP3	SWAP	D2
HEAP2	CLR.L	(A0)+
HEAP1	DBF	D2,HEAP2
	SWAP	D2
	DBF	D2,HEAP3
	MOVEA.L	BLLAB2(A6),A0
	LEA	HEAPAD(A6),A1
	CLR.L	(A1)
	MOVEA.W	MM_LNKFR,A2
	JSR	(A2)		set up the user heap
;
; Now set EQU labels to '5'
;
	MOVEQ	#2,D0
SLAB1	MOVE.W	D0,D1
	BSR	LNPTR		A0 -> LINN
	BEQ	SLAB2		no strand
SLAB4	LEA	LLEN-8(A0),A2	-> end of strand
SLAB3	CMPI.W	#-2,(A0)		end of labels? . .
	BEQ	SLAB2		. . yes
	MOVE.W	#5,TYPE(A0)	set type 5
	LEA	8(A0),A0		next item
	CMPA.L	A2,A0		end of chunk? ....
	BLT.S	SLAB3		.... no
	MOVE.L	-LLEN(A2),D1	-> next chunk
	BEQ	SLAB2		end of chunks
	LEA	8(D1.L),A0	-> 1st label
	BRA	SLAB4
SLAB2	DBF	D0,SLAB1		count strands
	CLR.W	CHM_NO(A6)
	CLR.L	BIN_OUT(A6)
	CLR.B	BIN_SWTCH(A6)
	CLR.B	ER_EA(A6)
	CLR.W	MAC_NO(A6)
	CLR.W	MAC_CT(A6)
	MOVE.W	#1,XREF_NO(A6)	set 1st no to 1
	MOVE.W	DEF_PCK,PCK(A6)
	MOVE.W	DEF_PWID,PWID(A6)
	MOVE.L	DEF_DATA,DATA(A6)
GWAG1_0	MOVEQ	#-1,D4		mark normal
;
GWAG1	MOVEA.L	ID_CON(A6),A0
	TST.B	DV_WMVEC(A6)
	BPL	RPTR		ptr on
	MOVEQ	#-1,D3
	LEA	HHX1,A1
	ADDA.L	(A1),A1
;	 LEA	 HEAD0_B,A1	 batch Heading
	TST.B	BATCH(A6) 	batch mode? . . .
	BNE	GWAG1_1		. .  . . . yes
	MOVEQ	#SD_CLEAR,D0
	TRAP	#3		clears window
	MOVE.B	CON,D1		color -> D1
	MOVE.B	CON+1,D2
	EXT.W	D2		width -> D2
	MOVEQ	#SD_BORDR,D0
	TRAP	#3
	LEA	HHX2,A1
	ADDA.L	(A1),A1
;	 LEA	 HEAD0,A1
GWAG1_1	TST.B	BF(A6)
	BNE	GWAG1_3
	LEA	SRT,A3
	ADDA.L	(A3),A3		-> UMT1
	JSR	(A3)		allows a large jump
GWAG1_3	TST.B	BATCH(A6) 	BATCH? . . .
	BEQ	GWAG1_2		. . . no
	ST	BF(A6)
	TST.W	D4
	BMI.S	GWAG5		normal
	LEA	QX_3,A1	---->	FATAL!
	ADDA.L	(A1),A1
	JMP	(A1)

QX_3	DC.L	QERX_3-*
HHX1	DC.L	HEAD0_B-*
HHX2	DC.L	HEAD0-*
HHX3	DC.L	HEAD0A-*
HHX4	DC.L	HEAD0B-*

GWAG1_2	TST.W	D4
	BMI.S	GWAG4		normal
	MOVE.B	D4,D1
	LEA	SRT,A3
	ADDA.L	4(A3),A3		-> INK
	JSR	(A3)
	LSR.W	#8,D4
GWAG4	LEA	HHX3,A1
	ADDA.L	(A1),A1
;	 LEA	 HEAD0A,A1
	LEA	SRT,A3
	ADDA.L	(A3),A3		-> UMT1
	JSR	(A3)		allows a large jump
	TST.W	D4
	BMI.S	GWAG3		normal
	MOVE.B	D4,D1
	LEA	SRT,A3
	ADDA.L	4(A3),A3		-> INK
	JSR	(A3)
	LEA	HHX4,A1
	ADDA.L	(A1),A1
;	 LEA	 HEAD0B,A1
	LEA	SRT,A3
	ADDA.L	(A3),A3		-> UMT1
	JSR	(A3)		allows a large jump
	MOVE.B	#GREEN,D1
	LEA	SRT,A3
	ADDA.L	4(A3),A3		-> INK
	JSR	(A3)
	BRA	QERX_3	---->	FATAL!
GWAG3	LEA	HEAD0B,A1
	BSR	UMT1
	BRA	GWAG_NORM
;
; BATCH action
;
GWAG5	MOVE.L	NO_ERRS(A6),D0
	BMI.S	GWAG8
	ADD.L	D0,TOT_BERRS(A6)	cleared in A_ACTION
GWAG8	MOVEA.L	B_FLS(A6),A0	next _ASM file
	MOVEA.L	A0,A5		keep address in A5
	MOVE.W	(A5)+,D0		length
	MOVE.W	D0,D1		keep length
	BNE	GWAG9		not ended
	TST.L	NO_ERRS(A6)
	BMI	GWAG10		ERRORs and WARNINGs done already
	BSR	GWAG_NOR1 	print number of ERRORs and WARNINGs
GWAG10	MOVE.L	TOT_BERRS(A6),D3
	BEQ	QUIT2		exit with no errors
	MOVEQ	#-1,D3		set 'not complete' to indicate ERRORs
	BRA	QUIT2		ended
GWAG9	ADDQ.W	#1,D0
	LSR.W	#1,D0		round to higher word
	LEA	(A5,D0.W*2),A1	-> next file
	MOVE.L	A1,B_FLS(A6)
	CMPI.W	#40,D1
	BGT	BEEP		ignore - too long
	LEA	PROMPT(A6),A1
	MOVE.W	D1,(A1)+
	BRA.S	GWAG6
GWAG7	MOVE.B	(A5)+,(A1)+	set filename in PROMPT
GWAG6	DBF	D1,GWAG7
	TST.L	NO_ERRS(A6)
	BMI	TEST_NAME
	MOVE.L	A0,-(A7)
	BSR	GWAG_NOR1
	MOVEA.L	(A7)+,A0
	BRA	TEST_NAME
;
GWAG_NOR1 BSR	PRERS		set up BUF with no of errors & warnings . .
	MOVE.L	#-1,NO_ERRS(A6)	stop it
	BRA	UMT		. . and print it
;
GWAG_NORM BSR	CURON		put on cursor
	TST.L	NO_ERRS(A6)
	BMI	GWAG2		processing not done - ignore
	BSR	GWAG_NOR1
;
;	Menu
;
GWAG2	MOVEQ	#IO_FBYTE,D0
	TRAP	#3
	CMPI.B	#244,D1
	BEQ	GWAG1_0 F4	- redraw
	ADDQ.B	#1,D1
	CMPI.B	#'2',D1
	BEQ.S	REPRINT
	CMPI.B	#'3',D1
	BNE.S	GWAG2		get 1,2, or F4
REPRINT	MOVE.B	D1,D2
	SUB.B	#48,D2
	MOVE.B	D2,D7		keep 1,2 in D7
	MOVEQ	#WHITE,D1
	BSR	INK
	MOVEQ	#0,D1
	BSR	AT
	CMPI.B	#2,D2
	BEQ.S	REP1		process
	LEA	HEAD0B,A1
	BRA.S	REP2		quit
REP1	LEA	HEAD0A,A1
REP2	BSR	UMT1
	MOVEQ	#GREEN,D1
	BSR	INK
	BSR	CUROF
	CMPI.B	#2,D7
	BNE	QUIT1		EXIT for good!
REP3	MOVEQ	#1,D0		ask for DATAD only
	BSR	SET_DP
	AT	0,5
;	 MOVEQ	 #0,D1		 re-entry after BEEP
;	 MOVEQ	 #5,D2
;	 BSR	 AT
	LEA	HEAD1,A1
	BSR	UMT1
	MOVEQ	#SD_NL,D0
	TRAP	#3		new line
;	 LEA	 BUF(A6),A1	 to get X-POS etc
;	 MOVEQ	 #SD_CHENQ,D0
;	 TRAP	 #3
;	 MOVE.W	 BUF+4(A6),D1	 X-POS
;	 SWAP	 D1
	MOVEQ	#0,D1		Point to start of string
	MOVE.W	PROMPT(A6),D1	Current length



REP6	MOVE.W	#40,D2		buffer length
	LEA	PROMPT+2(A6),A1	end of . .
	ADDA.W	D1,A1		. . string
	MOVEQ	#IO_EDLIN,D0
	TRAP	#3

; New v5.03

	TST.L	D0
	BEQ	REP5		Not buffer overflow
	AT	0,6		Point to start of prompt
	MOVEM.L	D5-7/A3,-(A7)
	BSR	BLP		Noise
	MOVEM.L	(A7)+,D5-7/A3
	MOVEQ	#IO_SSTRG,D0
	MOVEQ	#39,D2		send 39 characters
	LEA	PROMPT+2(A6),A1
	TRAP	#3
	MOVE.L	#$270027,D1	39 | 39
	BRA	REP6

; End of new

REP5	CMPI.B	#$1B,-1(A1)	ESC? . .
	BEQ	REP4		. . yes - abandon file
	LEA	PROMPT(A6),A0
	MOVE.L	A1,D0
	LEA	PROMPT+2(A6),A1
	SUB.L	A1,D0
	SUBQ.W	#1,D0
	MOVE.W	D0,(A0)		set length of name
	BNE	TEST_NAME OK
REP4	TST.B	DV_WMVEC(A6)
	BMI	GWAG1_0		No file - try again (not ptr)
	MOVEA.L	ID_CON(A6),A0
	AT	0,5
	CLS_BOT
	BRA	GWAG1_0
;
; batch entry point
;
TEST_NAME MOVEQ	#0,D3		OPEN_IN
	BSR	OPENFILE
	BNE	BEEP		can't open - try again
	MOVEQ	#64,D2		header length
	MOVEQ	#-1,D3
	LEA	O_BUF(A6),A1	space for header
	MOVEQ	#FS_HEADR,D0
	TRAP	#3
	TST.L	D0
	BNE	BEEP1		can't read header!!
	TST.B	-59(A1)		check type
	BNE	BEEP1		not type 0
	MOVE.L	A0,CH_IN(A6)
	PEA	CH_LST(A6)
	PEA	4		length needed
	PEA	0		mark 'no relocation'
	BSR	GSP
	LEA	12(A7),A7
	MOVE.L	A0,([CH_LST,A6])
	CLR.W	CH_NO(A6)
	LEA	PROMPT-2(A6),A1
	ADDA.W	2(A1),A1	set A1 to 4 bytes from the end of filename
	LEA	BUF(A6),A0
	MOVE.W	#4,(A0)+		set length
	MOVEQ	#3,D0		count
GW6	MOVE.B	(A1)+,(A0)+
	DBF	D0,GW6
	LEA	BUF(A6),A1
	LEA	TRAIL1,A0 	"_ASM"
	MOVEQ	#1,D0		ignore case
	MOVEA.L	A6,A5		keep A6
	SUBA.L	A6,A6
	MOVE.W	UT_CSTR,A2
	JSR	(A2)
	TST.L	D0
	BEQ.S	GW1
	MOVEQ	#4,D0		no _ASM - add 4 to length
GW1	MOVEA.L	A5,A6		restore A6
	LEA	BUF+2(A6),A0
	LEA	PROMPT(A6),A1
	ADD.W	(A1)+,D0		D0=length of name ex _ASM - 4
	MOVE.W	D0,-2(A0) 	insert length in BUF
	SUBQ.W	#4,D0
	BRA.S	GW2
;
SAVE_NME	BTST	#1,D4
	BEQ.S	SAVE_NM4		_TMP
	LEA	BIN_NME(A6),A5
	BRA.S	SAVE_NM3
SAVE_NM4	LEA	TMP_NME(A6),A5
SAVE_NM3	MOVE.W	(A0)+,D0		length of name
	MOVE.W	D0,(A5)+
	CMPI.W	#38,D0
	BGT	SAVE_NM5
	BRA.S	SAVE_NM1
SAVE_NM2	MOVE.B	(A0)+,(A5)+
SAVE_NM1	DBF	D0,SAVE_NM2
SAVE_NM5	RTS
;
GW3	MOVE.B	(A1)+,(A0)+	filename to BUF
GW2	DBF	D0,GW3
	MOVEQ	#3,D4		for 4 files
	LEA	CH_OUT(A6),A3
	LEA	TRAIL2,A2
GW4	MOVEQ	#3,D0
	MOVEA.L	A2,A1
	ADDQ.L	#4,A2
GW5	MOVE.B	(A1)+,(A0)+
	DBF	D0,GW5
	LEA	BUF(A6),A0	reset A0
	BTST	#0,D4		BIN or TMP file?
	BEQ	GW7
	BSR	SAVE_NME		yes
	LEA	BUF(A6),A0
GW7	MOVEQ	#3,D3		OPEN_OVER
	BSR	OPENFILE
	BNE	BEEP2	---->
	MOVE.L	A0,(A3)+
	LEA	BUF-2(A6),A0
	ADDA.W	2(A0),A0
	DBF	D4,GW4
	CLR.L	(A3)		set ID of _o 'zero'
	LEA	([ER_LST,A6],4),A0
	MOVE.L	A0,-4(A0)
	CLR.L	LINE_NO(A6)
	BSR	ST_LNO		sets PC_TH & PC_PR
	CLR.L	MARK(A6)
	MOVE.L	#-1,IF_LNO(A6)
	CLR.W	ACT_L(A6)
	CLR.W	IF_L(A6)
	CLR.B	TEMP_ON(A6)
	ST	IF_SW(A6)
	SUBA.L	A5,A5		set PC to 0
	TST.B	BATCH(A6) 	if BATCH . . .
	BNE	GWSET10		. . print filename
	LEA	HEAD2,A1		print "PASS 1"
	BRA	GWSET9
GWSET10	LEA	PROMPT(A6),A1
GWSET9	BSR	UMT
	LEA	O_BUF+4(A6),A0	 Set O_BUF for
	MOVE.L	A0,-4(A0) 	output to _BIN
	LEA	SEC_PC(A6),A0
	MOVE.W	#255,D0
GWSET6	CLR.L	(A0)+
	DBF	D0,GWSET6
	CLR.W	REL_SWTCH(A6)	clears DIP too
	MOVE.B	DEFAULT+1(A6),DIP(A6)
	MOVE.W	#-1,CRT_SEC(A6)	set for normal
	CLR.L	PC_TOT(A6)
	CLR.L	PC_INST(A6)
	CLR.L	RS(A6)
	CLR.L	P_MAC(A6) 	set zero 'P' file chain
	CLR.W	FLTYP(A6)
	MOVE.W	#-1,E_COM(A6)	set no 'COMMON'
	BSR	SET_MNE		sets Module name = Prompt
;
; PC_LST item is 'PC' (lwd) followed by 'section' (wd)
;  This is held in a set of chained chunks each PC_SZE long.
;  The 1st long word points to the next link or is zero.
;  PC_TH and PC_PR point to the current and previous 6 bytes .
;
GLIN	CLR.B	F_EA(A6)		clear EA jump marker
	CLR.B	ER_EA(A6) 	clear EA error jumper
	CLR.B	J_SIZE(A6)	clear absolute <ea> .L marker
	MOVE.L	A5,D3
	ADD.L	D3,([PC_TH,A6])	set PC and SECTION to PC_LST
	MOVE.W	CRT_SEC(A6),([PC_TH,A6],4)
	LEA	OBUF+4(A6),A0	Reset the pointers to
	MOVE.L	A0,-4(A0) OBUF	(for [EXT])
GLIN1
	LEA	LBUF(A6),A1
	MOVE.L	CH_IN(A6),D7	D7 is minus for MACRO
	MOVE.L	D7,D2
	BCLR	#31,D2
	BEQ.S	GLIN2
	LEA	MAC_BUF(A6),A1	line  -> MAC_BUF for MACRO
GLIN2	MOVEA.L	D2,A0
	MOVE.W	#256,D2
	MOVEQ	#-1,D3
	MOVEQ	#IO_FLINE,D0
	TRAP	#3
	TST.L	D0
	BEQ.S	DO_LINE
	CMPI.B	#-10,D0
	BNE	QER8	---->	FATAL!
	TST.W	D1		any bytes fetched?
	BEQ	IN_END		no
	MOVE.B	#10,(A1)		put LF in buffer
	ADDQ.W	#1,D1		and adjust count
;
DO_LINE	TST.L	D7		MACRO?
	BMI	MAC_LN		yes
DO_LINE1	LEA	LBUF(A6),A1
DO_LINE2	MOVEA.L	CH_TMP(A6),A0
	MOVE.W	D1,D2		no of bytes fetched
	MOVEQ	#IO_SSTRG,D0
	TRAP	#3
	TST.L	D0
	BNE	QER9	---->	FATAL!
	SUBA.W	D1,A1		reset pointer to instruction line
	MOVE.B	(A1)+,D0
	CMPI.B	#32,D0
	BEQ	DO_INSTR
	CMPI.B	#9,D0	TAB
	BEQ	DO_INSTR
	BSR	CH_LET
	SUBQ.L	#1,A1		(cond codes not affected)
	BEQ	DO_LAB
DO_LINE3	TST.L	IF_LNO(A6)
	BMI	INST_ED1		no IFs or between ENDIF and the next IF
	ADDQ.L	#1,IF_LNO(A6)	ignore comment lines for AND/OR_IF
INST_ED1	ADDQ.L	#1,LINE_NO(A6)
	BSR	ST_LNO		reset PC_TH & PC_PR
	LEA	OBUF(A6),A4
	MOVEA.L	(A4)+,A0
	BRA	I_END1
I_END2	MOVE.W	(A4)+,D5
	BSR	PUT_W
I_END1	CMPA.L	A0,A4
	BLT	I_END2
	BRA	GLIN
INST_END	BSR	PUT_W
	BRA	INST_ED1
;
; Replaces PC in A5 after an error
;
INST_ED2	LEA	O_BUF(A6),A0
	MOVE.L	(A0)+,D1
	SUB.L	A0,D1		amount in O_BUF
	ADD.L	BIN_OUT(A6),D1	file position  now
	ADD.L	PC_INST(A6),D1	A5 value at start of inst.
	SUB.L	PC_TOT(A6),D1	file pos.     "
	MOVE.L	D1,A5		reset PC
	LEA	OBUF+4(A6),A0
	MOVE.L	A0,OBUF(A6)	clear OBUF
	TST.L	EA_INSMK1(A6)
	BNE	INST_ED3
	MOVE.L	BINS(A6),D1	a new INS? . .
	BEQ	INST_ED1		. . no
	ADDQ.L	#4,D1		point to . .
	MOVE.L	D1,([BINS,A6])	. . start of chunk
	BRA	INST_ED1
INST_ED3	MOVE.L	EA_INSMK1(A6),BINS(A6)
	MOVE.L	EA_INSMK(A6),([BINS,A6]) reset INS position
	TST.L	([BINS,A6],-8)
	BEQ	INST_ED1		no further chunk
	MOVEA.L	([BINS,A6],-8),A0
	LEA	12(A0),A0
	MOVE.L	A0,-4(A0) 	clear the further chunk
	BRA	INST_ED1
;
; MACRO lines are adjusted
;  for parameters (\x) local LABELS (\@) MACRO LABEL (\.)
;  and <values> (| ... ~) from MAC_BUF <-> LBUF
;
MAC_LN	LEA	MAC_BUF(A6),A1
	CMPI.B	#128,(A1) 	'\' or '|' in line?...
	BNE	DO_LINE2		... no
	CLR.L	-(A7)		space for end of buffer address
	MOVEA.L	A1,A4		set A4 -> MAC_BUF
	LEA	LBUF(A6),A3
	MOVE.W	D1,D6		keep D1 in D6
	SUBQ.W	#1,D1
	ADDQ.L	#1,A1		go past '128'
	MOVEQ	#-1,D5		mark 1st time
	CLR.W	D5		mark not <value>
	BRA	MAC_LP1
MAC_LP	EXG	A3,A4		switch buffers
	MOVEA.L	A4,A1		set input
MAC_LP1	LEA	256(A3),A2	-> end of buffer
	MOVEM.L	A2,(A7)
	MOVEA.L	A3,A2		set output
	BNE	MAC_VAL		go to <value> if D5.W <>0
	SUBQ.W	#1,D1		set count-1 for DBF
	MOVEQ	#-1,D4		mark no '|' yet
MAC_LN3	MOVE.B	(A1)+,D0
	TST.L	D5		1st time? . .
	BPL	MAC_LN8		. . no
	CMPI.B	#'\',D0		only replace \x by . .
	BEQ	MAC_LN4		. . values in 1st pass
MAC_LN8	CMPI.B	#"|",D0
	BEQ	MAC_VI		mark start of <value>
	CMPI.B	#"~",D0
	BEQ	MAC_VO		mark end of <value>
MAC_LN5	CMPA.L	(A7),A2		too much? . .
	BGE	MAC_ER33		. . yes
	MOVE.B	D0,(A2)+
MAC_OX	DBF	D1,MAC_LN3
MAC_LN6	MOVE.L	A2,D1		end of new buffer
	SUB.L	A3,D1		new length
	TST.W	D5		any <value>? ...
	BNE	MAC_LP		... yes - do it
	MOVEA.L	A3,A1		set to start of buffer
	MOVEQ	#-1,D3		reset D3 for timeout
;
; Replace bytes = 0 by '\', =  1 by '|' and = 2 by '~' v 4.23
;
	MOVE.W	D1,D2		count
	BRA	MAC_LN2
MAC_LN7	MOVE.B	(A3)+,D0
	BEQ	MAC_LN1		'\'
	CMP.B	SBT1(A6),D0
	BEQ	MAC_LN9		'|'
	CMP.B	SBT2(A6),D0
	BNE	MAC_LN2		not '~'
	MOVE.B	#'~',-1(A3)
	BRA	MAC_LN2
MAC_LN9	MOVE.B	#'|',-1(A3)
	BRA	MAC_LN2
MAC_LN1	MOVE.B	#'\',-1(A3)
MAC_LN2	DBF	D2,MAC_LN7
	ADDQ.L	#4,A7		adjust stack
	BRA	DO_LINE2
MAC_LN4	MOVE.B	(A1)+,D0
	SUBQ.W	#1,D1		adjust count of chars in line
	CMPI.B	#'@',D0
	BEQ.S	MAC_AX
	CMPI.B	#'.',D0
	BEQ	MAC_LA		Set label info
	MOVE.B	D0,D3
	BSR	MAC_PAR
	TST.B	D0
	BEQ	MAC_NUM
	BPL	MAC_FND
	MOVE.B	D3,D0
	CMPI.B	#'\',D0		2nd '\'? . .
	BNE	MAC_ER33 ---->
	CLR.B	D0		set byte to zero
	BRA	MAC_LN5		. . yes - ignore the 1st
;
; Copy parameter to buffer, hiding | as 1 and ~ as 3
;
MAC_FND	BSR	MAC_GP		D2 = length of parameter
	BSR	MAC_PUT
	BRA	MAC_OX
MAC_PUT1	MOVE.B	-(A0),D0
	CMPI.B	#'|',D0
	BEQ	MAC_PUT2
	CMPI.B	#'~',D0
	BNE	MAC_PUT3
MAC_PUT2	SUBI.B	#123,D0
MAC_PUT3	MOVE.B	D0,(A2)+
MAC_PUT	DBF	D2,MAC_PUT1
	RTS
;	 BRA	 MAC_OX
;
; On entry D0.B = parameter number (1 to 61)
; On exit  D2.W = size of parameter A0 -> parameter
;
MAC_GP	LEA	([8,A7],-8),A0
	BRA	MAC_GP4
MAC_GP5	LEA	([3*4+8,A7],-8),A0
MAC_GP4	MOVEQ	#0,D2		in case answer is zero
	EXT.W	D0
	BEQ	MAC_GP3		zero -> null parameter
	CMP.W	6(A0),D0
	BHI	MAC_GP3		parameters not entered -> null
	SUBQ.W	#1,D0
	BRA	MAC_GP1
MAC_GP2	MOVE.W	-(A0),D2		count
	SUBA.W	D2,A0		go to next parameter
MAC_GP1	DBF	D0,MAC_GP2
	MOVE.W	-(A0),D2		count
MAC_GP3	RTS
;
MAC_AX	MOVE.B	#'^',(A2)+
	LEA	BUF+10(A6),A0
	MOVE.L	D5,-(A7)
	MOVE.L	A0,D5
	MOVE.W	CHM_NO(A6),D0	 current MAC..
	MOVE.W	([CHM_LST,A6],D0.W*8,-6),D0	.._CT
	EXT.L	D0
	MOVE.W	D1,D6
	BSR	LTOD
	MOVE.W	D6,D1
MAC_AX1	MOVE.B	(A0)+,(A2)+
	CMPA.L	D5,A0
	BLT.S	MAC_AX1
	MOVE.L	(A7)+,D5
	BRA	MAC_OX
;
MAC_LA	MOVE.W	([4,A7],-4),D0	Label number or -1
	BMI	MAC_OX		set blank to (A2)
	MOVEM.L	D3/A2,-(A7)
	MOVE.W	D0,D3		label number
	BSR	GNL
	BNE	QER5	---->	(shouldn't happen)
	MOVEA.L	A2,A0		-> label name
	MOVEM.L	(A7)+,D3/A2
	MOVEQ	#0,D0
	MOVE.B	(A0)+,D0		count in D0.W
	BRA	MAC_LA1
MAC_LA2	MOVE.B	(A0)+,(A2)+
MAC_LA1	DBF	D0,MAC_LA2
	BRA	MAC_OX
;
; Before performing the value the bytes are copied to A2
; with 1 and 3 being replaced by the true characters | and ~
;
MAC_VAL	MOVE.B	#32,(A1,D5.W)	set marker @ end of <value>
	BRA.S	MAC_VAL1
MAC_VAL2	MOVE.B	(A1)+,D6		copy bytes up
	CMP.B	SBT1(A6),D6	'|'? . .
	BEQ	MAC_VAL6		. . yes
	CMP.B	SBT2(A6),D6	'~'? . .
	BNE	MAC_VAL7		. . no
	MOVE.B	#"~",D6		replace ~
	BRA	MAC_VAL7
MAC_VAL6	MOVE.B	#"|",D6		replace |
MAC_VAL7	MOVE.B	D6,(A2)+
MAC_VAL1	DBF	D4,MAC_VAL2	to <value>
	ADDQ.L	#1,A1		jump over "|"
	MOVE.L	D1,D6		keep count
	CMPI.B	#'#',(A1)
	BEQ	MAC_FN		#functions
	BSR	GNUM
	CMPI.B	#1,D1
	BEQ	MAC_VALN		number
	CMPI.B	#-2,D1
	BNE	MAC_ER33A ---->	not string or number
	BSR	MAC_STR		set string to A2
MAC_VAL5	SUB.W	D5,D6		get number of ...
	SUBQ.W	#1,D6		... remaining bytes
	LEA	1(A4,D5.W),A1	point to after <value>
	BRA	MAC_VAL4
MAC_VAL3	MOVE.B	(A1)+,(A2)+
MAC_VAL4	DBF	D6,MAC_VAL3
	MOVE.L	A2,D1
	SUB.L	A3,D1		new count
	MOVEQ	#0,D5		set for 'normal' and mark not 1st time
	BRA	MAC_LP
;
MAC_FN	MOVEM.L	A1-3,-(A7)
	ADDQ.L	#1,A1		go past #
	BSR	STRG		get function
	BMI	MAC_ER74B ---->
	LEA	MA_LST,A0
	EXG	A2,A1
	MOVEQ	#MA_LEN,D1
	BSR	FIND
	EXG	A2,A1
	BMI	MAC_ER76B ---->
	CMPI.W	#12,D1
	BEQ	MAC_FN1		Don't test OPTS for "("
	CMPI.B	#'(',D0
	BNE	MAC_ER42B ---->	( expected
MAC_FN1	LEA	MA_RLST,A0
	ADDA.W	(A0,D1.W*2),A0
	JMP	(A0)
;
MA_LST	DC.W	3
	DC.B	'LEN'
	DC.W	5
	DC.B	'INSTR'
	DC.W	4
	DC.B	'LEFT'
	DC.W	5
	DC.B	'RIGHT'
	DC.W	3
	DC.B	'DEF'
	DC.W	3
	DC.B	'ABS'
	DC.W	5
	DC.B	'UCASE'
	DC.W	4
	DC.B	'PLEN'
	DC.W	4
	DC.B	'PARM'
	DC.W	2
	DC.B	'FR'
	DC.W	4
	DC.B	'REPL'
	DC.W	5
	DC.B	'LCASE'
	DC.W	4
	DC.B	'OPTS'
;
MA_LEN	EQU	13
MAB_LEN	EQU	12		number of ABS possibilities
MAB12	EQU	MAB8
MAB11	EQU	MAC_ER1B
MAB10	EQU	MACP5_1
MAB9	EQU	MACP5_2
MAB7	EQU	MAB8
MACP8	EQU	MACP9
MACP11	EQU	MACP9
MACP12	EQU	MACP7
;
	DS.W	0
	G_LST	MA_RLST,MACP,1,MA_LEN
	G_LST	MABS_L,MAB,1,MAB_LEN
;
; 1-> LEN 2-> INSTR 3 -> LEFT 4 -> RIGHT 5 -> DEF 6 -> ABS
; 7 -> UCASE 8 -> PARM 9 -> FR 10 -> REPL 11 -> LCASE 12 -> OPTS
;
; UCASE/LCASE
;
MACP7	MOVE.W	D1,D3		6 = UCASE 12 = LCASE
	BSR	GNUM
	ADDQ.L	#2,D1
	BNE	MAC_ER74B ---->
	CMPI.B	#')',D0
	BNE	MAC_ER43B ---->
	LEA	BUF(A6),A0	A0 ->string
	SUBQ.W	#7,D3		neg = UCASE
	BMI	MACP7_3		UCASE
	MOVE.B	#'A',D2
	MOVE.B	#'Z',D3
	BRA	MACP7_4
MACP7_3	MOVE.B	#'a',D2
	MOVE.B	#'z',D3
MACP7_4	MOVE.W	(A0)+,D0		length
	BRA	MACP7_1
MACP7_2	MOVE.B	(A0)+,D1
	CMP.B	D2,D1
	BLT	MACP7_1		out of range or done
	CMP.B	D3,D1
	BGT	MACP7_1		out of range or done
	TST.W	D3		UCASE? . .
	BMI	MACP7_5		. . yes
	BSET	#5,-1(A0) 	set to lower case
	BRA	MACP7_1
MACP7_5	BCLR	#5,-1(A0)
MACP7_1	DBF	D0,MACP7_2
	LEA	BUF(A6),A0	A0 -> upper case string
	BRA	MACP3_4
;
; LEN
;
MACP1	MOVE.B	(A1)+,D0		1st character
	CMPI.B	#"?",D0
	BNE	MACP1_4		Ignore a leading ?
	MOVE.B	(A1)+,D0
MACP1_4	CMPI.B	#'"',D0		is it "? . .
	BEQ	MACP1_1		. . yes
	CMPI.B	#"'",D0		is it '? . .
	BNE	MACP1_2		. . no
MACP1_1	MOVE.L	D5,-(A7)
	BSR	RAS1		get STRING string
	MOVEM.L	(A7)+,D5
	BMI	MAC_ER74B ---->
	BRA	MACP1_5
MACP1_2	BSR	GNUM1
	ADDQ.W	#2,D1
MACP1_3	BNE	MAC_ER74B ---->
MACP1_5	MOVE.W	BUF(A6),D2	set length
	EXT.L	D2		Added 20/4/03
	BRA.S	MACP2_3
;
; INSTR (target,match)
;
MACP2	MOVEQ	#0,D3		mark INSTR
MACP2_7	BSR	GNUM
	ADDQ.L	#2,D1
	BNE	MAC_ER74B ---->
	CMPI.B	#',',D0
	BNE	MAC_ER19B ---->	comma expected
	LEA	BUF(A6),A0	**********
	LEA	EX_BUF(A6),A2	*  Move  *
	MOVE.W	(A0)+,D0		* target *
	MOVE.W	D0,(A2)+		* string *
	BRA	MACP2_1		*   to   *
MACP2_2	MOVE.B	(A0)+,(A2)+	* EX_BUF *
MACP2_1	DBF	D0,MACP2_2	**********
	BSR	GNUM
	CMPI.W	#1,D3
	BPL	MACP3_1
	ADDQ.L	#2,D1
	BNE	MAC_ER74B ---->
	CMPI.B	#')',D0
	BNE	MAC_ER43B ---->
	LEA	BUF(A6),A2	match string (m)
	LEA	EX_BUF(A6),A0	target string (t)
	MOVE.W	(A2)+,D2		lm
	BEQ	MACP2_3
	NEG.W	D2		-lm
	ADD.W	(A0)+,D2		lt-lm
	BPL	MACP2_4
	MOVEQ	#0,D2		no match possible
	BRA	MACP2_3
MACP2_4	MOVE.W	-2(A2),D1 lm
	MOVEA.L	A2,A3
	MOVEA.L	A0,A1
	SUBQ.W	#1,D1		lm-1
MACP2_5	CMPM.B	(A3)+,(A1)+
	DBNE	D1,MACP2_5
	BEQ	MACP2_6		found
	ADDQ.L	#1,A0		try from the next byte
	DBF	D2,MACP2_4	count 1+lt-lm times
	MOVEQ	#0,D2		mark not found
	BRA	MACP2_3
;
MACP2_6	NEG.W	D2		-ct
	SUB.W	-2(A2),D2 	-ct-lm
	ADD.W	EX_BUF(A6),D2	lt-lm-ct
	ADDQ.W	#1,D2		lt-lm-ct+1
MACP2_3	MOVEM.L	(A7)+,A1-3
;
MAC_VALN	MOVE.L	D2,D0
	BSR	LTODZ		set signed ASCII
	BRA	MAC_VAL5
;
; LEFT
;
MACP3	MOVEQ	#1,D3		mark LEFT
	BRA	MACP2_7
;
MACP3_1	SUBQ.L	#1,D1
	BNE	MAC_ER75B ---->
	CMPI.B	#')',D0
	BNE	MAC_ER43B ---->
	TST.W	D2
	BPL	MACP3_2		set neg D2 to 0
	MOVEQ	#0,D2
MACP3_2	CMPI.B	#2,D3		1=left 2=right
	BEQ	MACP4_1
	CMP.W	EX_BUF(A6),D2
	BGE	MACP3_3
	MOVE.W	D2,EX_BUF(A6)
MACP3_3	LEA	EX_BUF(A6),A0
MACP3_4	MOVEM.L	(A7)+,A1-3
MACP3_5	PEA	MAC_VAL5
	BRA	MAC_STR3
;
; RIGHT
;
MACP4	MOVEQ	#2,D3		mark RIGHT
	BRA	MACP2_7
;
MACP4_1	MOVE.W	EX_BUF(A6),D0
	CMP.W	D0,D2	
	BLE	MACP4_2
	MOVE.W	D0,D2		limit o/put string to total length
MACP4_2	SUB.W	D2,D0		starting place
	LEA	EX_BUF(A6,D0.W),A0
	MOVE.W	D2,(A0)
	BRA	MACP3_4
;
; DEF
;
MACP5	BSR	GNUM
	ADDQ.W	#1,D1
	BEQ	MAC_ER1B	---->
	CMPI.W	#1,D1
	BEQ	MACP5_1 F
	CMPI.W	#5,D1
	BEQ	MACP5_1 F
MACP5_2	MOVEQ	#1,D2		True
	BRA	MACP2_3
MACP5_1	MOVEQ	#0,D2		False
	BRA	MACP2_3
;
; ABS
;			GNUM D1.L
; returns -1 = undefined	0 or 4
;	 0 = PC		2
;	 1 = numeric	1
;	 2 = string	-2
;	 3 = FP		-3
;	 4 = Quad word	-4
;	 5 = register list	-5
;	 6 = register	-6
;	 7 = FP reg list	-7
;
MACP6	BSR	GNUM
	ADDQ.W	#7,D1
	BMI	MAC_ER1B	---->
	CMPI.W	#11,D1
	BGT	MAC_ER1B	---->
	LEA	MABS_L,A2
	ADDA.W	(A2,D1.W*2),A2
	JMP	(A2)
;
MAB1	MOVEQ	#7,D2
	BRA	MACP2_3
MAB2	MOVEQ	#6,D2		Register
	BRA	MACP2_3
MAB3	MOVEQ	#5,D2		Register list
	BRA	MACP2_3
MAB4	MOVEQ	#4,D2		Quad word
	BRA	MACP2_3
MAB5	MOVEQ	#3,D2		FP
	BRA	MACP2_3
MAB6	MOVEQ	#2,D2		String
	BRA	MACP2_3
MAB8	MOVEQ	#-1,D2		Undetermined or EQU list
	BRA	MACP2_3		or error in GNUM
;
; PLEN/PARM/REPL
;
MACP9	MOVE.W	D1,D3		7=PLEN : 8=PARM : 10=REPL
	BSR	GNUM		get mac number
	SUBQ.L	#1,D1
	BNE	MAC_ER75B ---->	number expected
	CMPI.B	#')',D0
	BNE	MAC_ER43B ---->
	MOVE.B	D2,D0
	BSR	MAC_GP5 A0	-> parameter, D2 = length
	SUBQ.W	#8,D3
	MOVEM.L	(A7)+,A1-3
	BMI	MAC_VALN	PLEN
	BNE	MACP11_1	REPL
	BSR	MAC_PUT PARM
	BRA	MAC_VAL5
;
MACP11_3	MOVE.B	-(A0),D0		next character of par
	CMPI.B	#'>',D0		is it >? . .
	BNE	MACP11_2		. . no
	MOVE.B	D0,(A2)+		. . yes - double it
MACP11_2	MOVE.B	D0,(A2)+
MACP11_1	DBF	D2,MACP11_3
	BRA	MAC_VAL5
;
; FR(<strg1>,<num>|<strg2>)
;
; strg1 must be a reg list, num must be 0 or 1
; and strg2 must be a register
;
; Returns are:
; If num = 0 : the number of registers in reglist
;        = 1 : the reglist itself
;
; If strg2 is a register : 0 if not in the list
;		       k if the kth register
;
MACP10	BSR	GNUM
	ADDQ.L	#5,D1
	BNE	MAC_ER82B ---->	reglist expected
	CMPI.B	#',',D0
	BNE	MAC_ER19B ---->	comma expected
	MOVE.L	D2,D3		keep the reglist
;
; See if we have a register else 0 or 1
;
	MOVEA.L	A1,A0		keep the place
	MOVEQ	#16,D1		to look for D0 to A7
	BSR	EA_GTR		got a register? . .
	BPL	FR_REG		. . yes
	ADDQ.L	#1,D1
	BNE	MAC_ER1B	---->	fault in number/label	
	MOVEA.L	A0,A1		replace the place
	BSR	GNUM
	SUBQ.L	#1,D1
	BNE	MAC_ER1B	---->	fault in number/label
	TST.L	D2
	BEQ	FR_LEN		return the length
;
; Reglist in D3
;
	MOVE.L	D3,D2
	BRA	MACP2_3
;
; reglist in D3, D2 = 0
;
FR_LEN	LSL.W	#1,D3		go through D3 . .
	BCC	FR_LEN1		. . counting . .
	ADDQ.L	#1,D2		. . registers
	TST.W	D3		ended? . .
FR_LEN1	BNE	FR_LEN		. . no
	BRA	MACP2_3
;
; reglist in D3
;
FR_REG	
	BTST	D1,D3		is register in list? . .
	BEQ	FR_REG1		. . no!!
	EOR.W	#15,D1		k -> 15 - k
	LSL.W	D1,D3		cut off the later registers
	MOVEQ	#0,D2		set the count to zero
	BRA	FR_LEN
;
FR_REG1	MOVEQ	#0,D2		set zero count
	BRA	MACP2_3
;
; OPTS
;
MACP13	MOVEQ	#0,D2
	MOVE.B	DIP(A6),D2
	BRA	MACP2_3
;
MAC_ER1B	MOVEQ	#1,D1
MAC_ERZ	MOVEM.L	(A7)+,A1-3
	BRA	MAC_ERY
MAC_ER19B MOVEQ	#19,D1
	BRA	MAC_ERZ
MAC_ER33B MOVEQ	#33,D1
	BRA	MAC_ERZ
MAC_ER42B MOVEQ	#42,D1
	BRA	MAC_ERZ
MAC_ER43B MOVEQ	#43,D1
	BRA	MAC_ERZ
MAC_ER74B MOVEQ	#74,D1
	BRA	MAC_ERZ
MAC_ER75B MOVEQ	#75,D1
	BRA	MAC_ERZ
MAC_ER76B MOVEQ	#76,D1
	BRA	MAC_ERZ
MAC_ER82B MOVEQ	#82,D1
	BRA	MAC_ERZ
;
MAC_ER33A MOVEQ	#33,D1
MAC_ERY	BSR	DO_ERR		Test of IF_SW put to DO_ERR 25/5/03
	BRA	MAC_VAL5
;
MAC_ER33	MOVE.W	D1,-(A7)
	MOVEQ	#33,D1
MAC_ERX	TST.B	IF_SW(A6)
	BEQ.S	MAC_ERX1		don't signal error (IF_SW off)
	BSR	DO_ERR
MAC_ERX1	MOVE.W	(A7)+,D1
	BRA	MAC_OX
MAC_ER31	MOVE.W	D1,-(A7)
	MOVEQ	#31,D1
	BRA.S	MAC_ERX
;
; replaces "\0" by the number of parameters
;
MAC_NUM	MOVE.W	#'  ',(A2)+	set no of PARS -> spaces
	MOVEQ	#0,D0
	MOVE.W	([4,A7],-2),D0	no of parameters
	MOVEA.L	A2,A0
	MOVE.W	D1,D6
	BSR	LTOD		set ASCII no of parameters
	MOVE.W	D6,D1
	CMPI.B	#32,-2(A2)
	BNE	MAC_OX
	SUBQ.L	#1,A2
	MOVE.B	(A0),-1(A2)	only one digit
	BRA	MAC_OX
;
; Here we look for a "|" "~" pair. When a macro line
; has either \ or | in it, a real | or	~ must be doubled.
; A doubled | or ~ is replaced by 1 or 3.
;
MAC_VI	TST.W	D5
	BNE	MAC_LN5		~ found - do nothing
	BSR	MAC_LEN
	MOVE.L	D6,D4		set relative pointer to D4
	BRA	MAC_LN5
;
MAC_VO	TST.W	D5
	BNE	MAC_LN5		~ found - do nothing
	TST.L	D4
	BMI	MAC_ER33	---->	no "|" yet
	BSR	MAC_LEN
	MOVE.W	D6,D5		set relative pointer to D5
	BRA	MAC_LN5
;
MAC_LEN	MOVE.L	A2,D6
	SUB.L	A3,D6
	RTS
;
; Copies string from A0 to A2 replacing | by 1 and ~ by 3
;
MAC_STR	LEA	BUF(A6),A0
MAC_STR3	MOVE.W	(A0)+,D0		length
	BRA	MAC_STR1
MAC_STR2	MOVE.B	(A0)+,D1
	CMPI.B	#'|',D1
	BNE	MAC_STR6
	MOVE.B	SBT1(A6),D1
	BRA	MAC_STR5
MAC_STR6	CMPI.B	#'~',D1
	BNE	MAC_STR5
	MOVE.B	SBT2(A6),D1
MAC_STR5	MOVE.B	D1,(A2)+
MAC_STR1	DBF	D0,MAC_STR2
	RTS
;
DO_INSTR	CMPI.B	#32,(A1)+
	BEQ.S	DO_INSTR
	CMPI.B	#9,-1(A1)
	BEQ.S	DO_INSTR
	CMPI.B	#10,-(A1) 	this replaces A1 -> character
	BEQ	INST_ED1		allow spaces/LF after LABEL
	MOVE.B	(A1),D0		character we're at
	BSR	CH_LET		test if a LABEL character or 0 to 9
	ADDQ.L	#1,D0
	BEQ	DO_LINE3		no - so a comment
	BSR	SET_PC		keeps position for errors
	BSR	STRGA		allow '.' as a separator
	BMI	PR_E21 ---->
	MOVE.L	D0,D4
	CMPI.B	#32,D0
	BLE.S	INS_OK		TAB, SPACE or ENTER
	CMPI.B	#".",D0
	BNE	PR_E9 ---->
INS_OK	MOVE.W	(A2)+,D1		length of inst
	CMPI.W	#9,D1
	BGT	IN_MACE		might be a MACRO
	LEA	INST_TBLE,A0
	ADDA.W	(A0,D1.W*2),A0
	JMP	(A0)
;
INST_TBLE DC.W	INST_TW-INST_TBLE
	DC.W	INST_TW-INST_TBLE
	DC.W	INST_TW-INST_TBLE
	DC.W	INST_TH-INST_TBLE
	DC.W	INST_FO-INST_TBLE
	DC.W	INST_FI-INST_TBLE
	DC.W	INST_SI-INST_TBLE
	DC.W	INST_SE-INST_TBLE
	DC.W	INST_EI-INST_TBLE
	DC.W	INST_NI-INST_TBLE

;
; INST_2 = length (Wd) + Insts (Wd)
; INST_3 = length (Wd) + Insts|0 (Long Wd)
; INST_4 = length (Wd) + Insts (Long Wd)
; INST_5 = length (Wd) + Insts|0 (3 Wds)
; INST_6 = length (Wd) + Insts (3 Wds)
; INST_7 = length (Wd) + Insts|0 (2 Long Wds)
; INST_8 = length (Wd) + Insts (2 Long Wds)
; INST_9 = length (Wd) + Insts|0 (5 Wds)
;
; All lists are in reverse order
;
INST_TH	LEA	INST_3,A0
	MOVE.W	(A0)+,D2		no of insts
	MOVE.L	(A2),D3		this inst
	CLR.B	D3
INST_TH1	CMP.L	(A0)+,D3
	DBEQ	D2,INST_TH1
	BNE	IN_MACE ---->
	BRA	INST_THE
;
INST_TW	CMPI.W	#2,D1
	BNE	IN_MACE ---->
	LEA	INST_2,A0
	MOVE.W	(A2),D3
	MOVE.W	(A0)+,D2		no of insts
INST_TW1	CMP.W	(A0)+,D3
	DBEQ	D2,INST_TW1
	BNE	IN_MACE ---->
	BRA	INST_TWE
;
INST_FO	LEA	INST_4,A0
	MOVE.L	(A2),D3
	MOVE.W	(A0)+,D2		no of insts
INST_FO1	CMP.L	(A0)+,D3
	DBEQ	D2,INST_FO1
	BNE	IN_MACE ---->
	BRA	INST_FOE
;
INST_FI	LEA	INST_5,A0
	MOVE.L	(A2),D3
	MOVE.W	(A0)+,D2		no of insts
	MOVE.B	4(A2),D7		inst to D3 & D7
	BRA.S	INST_FI1
INST_FI3	ADDQ.L	#2,A0
INST_FI1	CMP.L	(A0)+,D3
	BNE.S	INST_FI2
	CMP.B	(A0),D7
INST_FI2	DBEQ	D2,INST_FI3
	BNE	IN_MACE ---->
	BRA	INST_FIE
INST_SI	LEA	INST_6,A0
	MOVE.W	(A0)+,D2
	MOVE.L	(A2),D3
	MOVE.W	4(A2),D7
	BRA.S	INST_SI1
INST_SI3	ADDQ.L	#2,A0
INST_SI1	CMP.L	(A0)+,D3
	BNE.S	INST_SI2
	CMP.W	(A0),D7
INST_SI2	DBEQ	D2,INST_SI3
	BNE	IN_MACE ---->
	BRA	INST_SIE
INST_SE	LEA	INST_7,A0
	MOVE.W	(A0)+,D2		no of 7_insts - 1
	MOVE.L	(A2),D3		1st 4 letters
	MOVE.L	4(A2),D7
	CLR.B	D7		2nd 3 letters + blank
INST_SE2	CMP.L	(A0)+,D3
	BNE.S	INST_SE1		not found
	CMP.L	(A0),D7
INST_SE1	ADDQ.L	#4,A0
	DBEQ	D2,INST_SE2	go on till found
	BNE	IN_MACE	---->	not found
	BRA.S	INST_SEE	7-END
INST_EI	LEA	INST_8,A0
	MOVE.W	(A0)+,D2		no of 8_insts - 1
	MOVE.L	(A2),D3		1st 4 letters
	MOVE.L	4(A2),D7		2nd 4 letters
INST_EI2	CMP.L	(A0)+,D3
	BNE.S	INST_EI1		not found
	CMP.L	(A0),D7
INST_EI1	ADDQ.L	#4,A0
	DBEQ	D2,INST_EI2	go on till found
	BNE	IN_MACE		not found
	BRA.S	INST_EIE		8_END
INST_NI	LEA	INST_9,A0
	MOVE.W	(A0)+,D2		no of 9_insts
	MOVE.L	(A2),D3		1st 4 letters
	MOVE.L	4(A2),D7		2nd 4 letters
	MOVE.B	8(A2),D1		last letter
INST_NI2	CMP.L	(A0)+,D3
	BNE.S	INST_NI1		not this one
	CMP.L	(A0),D7
	BNE.S	INST_NI1		nor this
	CMP.B	4(A0),D1
INST_NI1	ADDQ.L	#6,A0
	DBEQ	D2,INST_NI2
	BNE	IN_MACE		not found
	ADD.W	INST_8,D2
	ADDQ.W	#1,D2
INST_EIE	ADD.W	INST_7,D2
	ADDQ.W	#1,D2
INST_SEE	ADD.W	INST_6,D2
	ADDQ.W	#1,D2
INST_SIE	ADD.W	INST_5,D2
	ADDQ.W	#1,D2
INST_FIE	ADD.W	INST_2,D2
	ADDQ.W	#1,D2
INST_TWE	ADD.W	INST_4,D2
	ADDQ.W	#1,D2
INST_FOE	ADD.W	INST_3,D2
	ADDQ.W	#1,D2
INST_THE	CMPI.W	#2,D2
	BLE	PR_EQ		REG (2), SET (1) or EQU (0)
;
INS_NOM	LEA	PRO_LST,A0
	LSL.W	#3,D2
	ADDA.W	D2,A0
INS_NOM1	MOVEQ	#0,D2		prepare for 'neg' prog no (IF . .)
	MOVE.W	(A0)+,D5
	MOVE.L	(A0)+,D7
	MOVE.B	(A0)+,D2
	CMPI.W	#$FF,D2		ambiguous instruction? . . .
	BEQ	INS_AMB		. . . yes
	MOVE.B	(A0)+,D3
	BMI	QER4	---->	FATAL
	CMPI.B	#NO_SEPS,D3
	BGT	QER4	---->	FATAL
	MOVE.B	D4,D0
	MOVEQ	#-1,D1
	EXT.W	D3
	LEA	INS_TAB,A0
	ADDA.W	(A0,D3.W*2),A0
	JMP	(A0)
;
; Here D7.W = 0 to 4 for the seven ambiguous instructions
;  PTESTR, PFLUSH, PFLUSHA, PMOVE, PTESTW, PLOADR, PLOADW
;
; INS_AMB looks up PTABLE1 given D7.W and bits 1 to 3 of DIP(A6)
; to get the true PRO_LST values.
;
INS_AMB	BFEXTU	DIP(A6){4:3},D0
	MOVE.W	D0,D2
	LSL.W	#3,D0
	SUB.W	D2,D0		7*D0
	ADD.W	D7,D0
	MOVE.B	PTABLE1(D0.W),D0
	BMI	PR_E21	---->	illegal instruction
	EXT.W	D0
	LEA	PTABLE2(D0.W*8),A0
	BRA	INS_NOM1		go back and replace D5, D7, D2
;
PTABLE1	DC.B	0,1,2,-1,11,-1,-1	      68040
	DC.B	3,4,5,6,12,14,16	      68030
	DC.B	3,4,5,7,12,-1,-1	      68EC030
	DC.B	8,9,5,10,13,15,17	      68851
;
INS_TAB	DC.W	INS_T0-INS_TAB
	DC.W	INS_T1-INS_TAB
	DC.W	INS_T2-INS_TAB	This sets .S -> .B
	DC.W	INS_T3-INS_TAB
	DC.W	INS_T4-INS_TAB
	DC.W	INS_T5-INS_TAB
	DC.W	INS_T6-INS_TAB
	DC.W	INS_T7-INS_TAB
	DC.W	INS_T8-INS_TAB
	DC.W	INS_T9-INS_TAB
	DC.W	INS_T10-INS_TAB
	DC.W	INS_T11-INS_TAB
	DC.W	INS_T12-INS_TAB
	DC.W	INS_T2-INS_TAB	This sets .S -> .W
	DC.W	INS_T14-INS_TAB
;
INS_SPW	MOVEQ	#1,D1	'W'
	BRA.S	INS_SPA
INS_SPL	MOVEQ	#2,D1	'L'
	BRA.S	INS_SPA
INS_SPX	MOVEQ	#13,D1	'X'
INS_SPA	CMPI.B	#".",D0
	BNE.S	INS_SPB
	RTS
;
INS_SPB	ADDQ.L	#4,A7		adjust stack
INS_T0	CMPI.B	#32,D0
	BEQ	INS_SP
	CMPI.B	#9,D0
	BNE	PR_E17 ---->
	BRA	INS_SP
INS_T5	BSR	INS_SPW
INS_T5A	BSR	DO_SIZE
	CMPI.W	#0,D1
	BLE	PR_E16 ---->
	BRA.S	INS_T0
INS_T3	BSR	INS_SPA
	BRA.S	INS_T4A
INS_T4	BSR	INS_SPW
INS_T4A	BSR	DO_SIZE
INS_T4B	BMI	PR_E16 ---->
	BRA	INS_T0
INS_T6	CMPI.B	#32,D0
	BLE	INS_SP		TAB, SPACE or ENTER
	CMPI.B	#".",D0
	BNE	PR_E15 ---->
	BRA.S	INS_T5A
INS_T1	CMPI.B	#10,D0
	BEQ	INS_Q
	CMPI.B	#9,D0
	BEQ	INS_Q
	CMPI.B	#32,D0
	BNE	PR_E9  ---->
	BRA	INS_Q
INS_T2	CMPI.B	#32,D0
	BEQ.S	INS_T2C
	CMPI.B	#9,D0
	BEQ	INS_T2C
	CMPI.B	#".",D0
	BNE	PR_E15
	MOVE.B	(A1)+,D1		Size
	MOVE.B	(A1)+,D0		Separator
;
; New bit (L -> W for Bcc,BSR if LOW_EA)
;
	ANDI.B	#$DF,D1		Make upper case
	CMPI.B	#"S",D1
	BNE.S	INS_T2A
	MOVEQ	#0,D1		-> B
	CMPI.B	#2,D3
	BEQ	INS_T0		Bcc
INS_T2D	MOVEQ	#1,D1		-> W
	BRA	INS_T0		XREF
INS_T2A	BTST	#4,DIP(A6)	LOW_EA? . .
	BEQ.S	INS_T2B
	CMPI.B	#2,D3		Bcc/BSR? . .
	BNE	INS_T2B		. . no
	CMPI.B	#'L',D1
	BEQ	INS_T2D		Set L -> W for low_ea
INS_T2B	SUBQ.L	#2,A1		restore A1
	BRA	INS_T4A
;
; End of alterations
;
INS_T2C	MOVEQ	#3,D1
	BRA	INS_T0
INS_T7	BSR	INS_SPX
	BSR	DO_SIZEF
	BRA	INS_T4B
INS_T8	BSR	INS_SPX
	BSR	DO_SIZEF
	CMPI.B	#2,D1
	BEQ	INS_T0
INS_T8A	CMPI.B	#13,D1
INS_T8B	BEQ	INS_T0
	BRA	PR_E16	---->
;
INS_T9	BSR	INS_SPA
	BRA	INS_T5A
INS_T10	BSR	INS_SPW
	BSR	DO_SIZEQ
	BRA	INS_T4B
INS_T11	BSR	INS_SPL
	BSR	DO_SIZE
	CMPI.B	#2,D1		'L'
	BRA	INS_T8B
INS_T12	BSR	INS_SPX
	BSR	DO_SIZEF
	BRA	INS_T8A
INS_T14	BSR	INS_SPX		Default X
	BSR	DO_SIZEX
	BRA	INS_T4B
;
IN_MACE	LEA	BUF(A6),A2
	BSR	NMAC_NO
	BNE	PR_E21 ---->	not a MACRO
	MOVE.W	(A0),D1		set macro number
	MOVE.B	TYPE(A0),D5	max no of pars
	MOVEQ	#31,D2		instruction number
	CMPI.B	#10,-1(A1)
	BNE	INS_SP		more to come
	SUBQ.L	#1,A1		set A1 pointing to LF
INS_SP	CMPI.B	#32,(A1)+
	BEQ.S	INS_SP
	CMPI.B	#9,-1(A1)
	BEQ.S	INS_SP
	SUBQ.L	#1,A1
	MOVE.B	-1(A1),D0
	CMPI.B	#$FB,D2		'RS', 'FREG' or 'EQUR? . .
	BLS	INS_Q		. . no
	MOVE.B	D1,SIZE(A6)
	BRA	PR_EQ
INS_Q	TST.B	D1		.B?
	BNE.S	INS_LB		no
	CMPI.W	#23,D2		DS?
	BEQ.S	INS_LB1		yes
	CMPI.W	#24,D2		DC?
	BEQ.S	INS_LB1		yes
	CMPI.W	#109,D2		DCB?
	BEQ	INS_LB1		yes
INS_LB	BSR.S	INS_LB3		set PC to even
INS_LB1	MOVE.L	D1,D3
	CLR.L	K_MARK(A6)
	MOVE.W	MARK(A6),D4
;
;  MARK = 0 for no previous label
;	1 for new label
;	2 for SET label (type 5)
;	4 for XREF label or SET label (wrong type)
;	5 for undetermined label
;
	BEQ.S	INS_LB2		no previous LABEL
	CLR.W	MARK(A6)
	MOVE.W	MARK+2(A6),D1	label no
	BSR	LNPTR		A0 -> LINN
	CMPI.B	#30,D2		MACRO? . .
	BNE	INS_LB6		. . no
	MOVEA.L	A0,A2		set A2 -> LINN
	BRA	INS_LB2
INS_LB6	BTST	#0,D4		0 = error
	BNE.S	INS_LB5		not a SET label or error
	ORI.W	#3,TYPE(A0)
	BRA	PR_E23	---->
INS_LB5	ORI.W	#6,TYPE(A0)
	MOVE.L	A5,VAL(A0)
	MOVE.W	CRT_SEC(A6),(A0)
INS_LB2	EXG	D3,D1		replace size and set MACRO label no in D3
	BCLR	#7,D2		bit 7 of prog no set for IF insts
	BNE.S	INS_LB4		always obey IF insts
	TST.B	IF_SW(A6)
	BEQ	INST_ED1		don't do instruction if switch OFF
INS_LB4	LEA	PR,A0
	ADDA.L	-4(A0,D2.W*4),A0
	MOVE.L	A5,PC_NOW(A6)	value of *
	ADDQ.L	#2,A5
	MOVE.B	D1,SIZE(A6)	set SIZE
	JMP	(A0)
;
INS_LB3	MOVE.L	A5,D3		PC
	BTST	#0,D3		even?
	BEQ.S	INS_LB3X		yes
	TST.B	D2
	BMI.S	INS_LB3X		don't set (IF's)
	TST.B	IF_SW(A6)
	BEQ	INS_LB3X		don't set (IF switch off)
	BFTST	BRY{D2:1}           if prog no. bit is on don't 'even'
	BNE	INS_LB3X
	ADDQ.L	#1,A5		set to WORD boundary
	ADDQ.L	#1,([PC_TH,A6])	set PC even
	MOVE.W	([PC_TH,A6],4),D3	does this section ..
	CMP.W	([PC_PR,A6],4),D3	.. equal the last? ..
	BEQ.S	INS_LB3Y		... yes
	BSET	#6,([PC_TH,A6])	mark 
INS_LB3Y	MOVE.L	D5,-(A7)
	MOVEQ	#0,D5
	BSR	PUT_B		put zero byte to _BIN
	MOVE.L	(A7)+,D5
INS_LB3X	RTS
;
; BRY stops the following instructions from -> even PC
;
;    INST no	Name
;	25	DATA, PCK, PWID, FILETYPE
;	27	Set of QMAC instructions to be ignored
;	30	MACRO, MACROP
;	31	any macro name
;	(52	PWID)
;	84	SECTION, COMMON
;	85	XDEF, XREF
;	86	O_FILE, REL_FILE
;	87	LOW_EA, HIGH_EA, CASE_DIFF, CASE_IND, ERR, LST
;	88	MODULE
;	89	COMMENT
;	92	68040, 68030, 68EC30, 68851
;	106	RS_SET
;	107	ERROR, WARNING
;	110	LIST, NOLIST
;	
BRY	DC.W	0,$53,0,$800,0,$FC8,$3A,0
;
; DO_LAB
;	   LABEL layout (for MACROs and SECTIONs too)
;
; All names are divided into three strands by hashing.
; Within a strand each name is held as a one byte length
; followed by the name itself. All names are constrained
; to be no longer than 32 bytes.
;
; Each strand consists of a series of chained 'chunks', each
; of length CHLEN, allocated within a user heap.
;
; The format of the name chunk is:-
;   _________________________________________________________
;  |	FS    |	  AC     | len  |<- name ->|<- etc . . . |
;       (lwd)	 (lwd)	(byte)
;
; FS points to the first free space for a name (absolute address)
; AC is the address of the next chunk, or 0 if it is the last.
;
; The first address of each of the three strands is held in three
; long words starting at:
;
;   LAB_LST  for LABELs
;   SEC_LST  for SECTIONs/COMMMONs and
;   MAC_LST  for MACROs
;
;  If an address is zero no chunk has been allocated yet.
;
; A symbol number is made up as 4 times the position in the
; strand plus the strand number (0, 1, or 2).
;
; Information corresponding to a symbol is held in an item 8
; bytes long. The items are held in chunks of size LLEN allocated
; in the same way as name chunks.
;
; The format of an information chunk is:-
;
;  _______________________________________________
; |   AC	 | spare |<   item	  >|<  etc  ....	|
;   (lwd)    (lwd)	  (8 bytes)
;
; AC is the address of the next chunk (0 if none)
;
; Each item is:-
;
;  ____________________________
; |  num	|   value     | type |
;    (wd)     (lwd)       (wd)
;
; Num is -2 to signal the 1st free item in the chunk. Otherwise
; the meaning of the contents depends on the type of symbol.
;
; For LABELs num is zero unless it is of PC type when num is the
; section number (-1, 0, 1, etc).
;
; For SECTIONs/COMMONs/ORGs num is the section number (as for LABELs)
; and type is 0, 1, 2 for SECTIONs/COMMONs/ORGs. Value is unused for
; SECTIONs/COMMONs but is 'k' for ORGs. 'k' is the PC setting at the
; start of that particular ORG.
;
; For MACROs num is the macro number and the rest of the item is unused.
;
; For LABELs:
;
;   Value is the value of the label whether PC or scalar or
;	is the address of 1) an EQU list or
;			2) an entry in the FP_LST,
;			 STR_LST or QUD_LST
;
;    XREF value is its <id> in bits 0 - 15 (inserted @ PASS2)
;
;   Type - bits 4-5 indicate	'normal' if 0 and FP, 1 Quad, 2  String 3
;	-bit 6	indicates 'normal' if 0 and SET if 1
;
;	for normal labels bits 0 - 1 have the meaning:
;			  0	unknown
;			  1	N (a scalar number)
;			  2	PC
;			  3	Error
;
;			bits 2 - 3 have the meaning
;			  0	awaiting definition
;			  1	defined
;			  2	EQU list
;
;	for FP or String labels bits 4 - 5 have the meaning
;			  1	FP
;			  2	Quad word
;			  3	String
;
;	for XDEF & XREF labels bits 12 - 15 are used:
;		bits 12- 13 = 1 for XDEF & 2 for XREF
;		for XREF labels bits 14 - 15 indicate
;		   0 = B, 1 = W, 2 = L
;
;	 REG labels have type $105, EQUR labels $205 and FREG $305
;
DO_LAB	TST.B	IF_SW(A6)
	BEQ	INST_ED1		ignore label
	BSR	SET_PC		keep position in case of error
	BSR	STRG
	BMI	PR_E6 ---->
	CMPI.W	#32,(A2)
	BLE.S	DO_LAB1
	MOVE.W	#32,(A2)		set len <= 32
	BSR	PR_W4		truncation warning
DO_LAB1	CMPI.B	#32,D0
	BLE	DO_LAB2
	CMPI.B	#":",D0
	BNE	PR_E9 ---->
DO_LAB2	MOVE.B	D0,D4		keep D0.B
	LEA	D_LIST,A0
	MOVEQ	#19,D1
	MOVE.L	A1,-(A7)
	MOVEA.L	A2,A1
	BSR	FIND1
	MOVEA.L	(A7)+,A1
	TST.W	D1
	BPL	PR_E20 ---->
	BSR	NLAB_NO
	BEQ.S	IN_LIST
	BSR	NNEW_LAB
	MOVEQ	#1,D0		for ordinary MARK
	BRA.S	IN_OK
IN_LIST	MOVE.W	TYPE(A0),D2
	MOVEQ	#1,D0		for ordinary MARK
	BTST	#13,D2		XREF . . .
	BEQ	IN_LIST1		. . . no
IN_LIST3	MOVEQ	#4,D0		signal an error (unless MACRO)
	BRA	IN_OK1
;
IN_LIST1	MOVE.W	D2,D3
	ANDI.W	#12,D2
	BNE	IN_LIST2		label determined
	MOVEQ	#5,D0		mark old undetermined label
	BRA	IN_OK		(LAB not determined)
;
IN_LIST2	BTST	#6,D3		SET type label? . . .
	BEQ	IN_LIST3		. . . no
	ANDI.W	#7,D3
	CMPI.W	#5,D3
	BNE	IN_LIST3		can't SET this
	MOVEQ	#2,D0		for MARK
IN_OK	TST.W	MARK(A6)
	BEQ.S	IN_OK1		No immediately preceding LABEL
	MOVE.L	D1,D3
	MOVEQ	#12,D1
	MOVE.L	D0,-(A7)
	BSR	NN_LG2		get 12 bytes
	MOVE.L	(A7)+,D0
	MOVEA.L	A0,A3
	MOVE.W	MARK+2(A6),D1	LAB1 no
	BSR	LNPTR		A0 -> LINN
	MOVE.L	D3,D1
	EXG	A0,A3
	MOVE.L	MARK(A6),K_MARK(A6) keep the previous MARK . .
	MOVE.L	VAL(A3),K_VAL(A6)	. . Label value and . .
	MOVE.W	TYPE(A3),K_TYP(A6)	. . type
	MOVE.L	A0,VAL(A3)	set EQ pointer to VAL
	LEA	6(A0),A0
	MOVE.W	#1,(A0)+		sign -> +
	MOVE.W	D1,(A0)+		No of LAB2
	ORI.W	#$A,TYPE(A3)	LAB type to PC/EQ list
	CLR.W	(A0)+		mark end of EQ list
IN_OK1	MOVE.W	D1,2+MARK(A6)	set LAB2 no to MARK+2
	MOVE.W	D0,MARK(A6)	set 1 or 2
	CMPI.B	#10,D4		is separator ENTER?
	BEQ	INST_ED1		yes
	BRA	DO_INSTR
;
; PASS2 (preceded by IN_END)
;
; IN_END unwinds the nesting of IN'd files
;   _________     _________	  ________________________	 ________
;  |_________|\  | CH_LST  |	 |	 CHM_LST	       |	|________|
;    CH_IN     \ |	       |	 |	    |	       |	 CHM_NO
;   _____       \|_________|	 |____________|____________|	/
;  |_____|-----> |1|       |-->|MAC no|Ident|  File pos  | /
;   CH_NO        |---------|	 |-------------------------|/ end of list
;	       |_________|	 |_________________________|
;
IN_END	MOVE.W	CH_NO(A6),D4	more IN's? . .
	BNE.S	IN_END1		. . yes
	TST.W	MARK(A6)		Unprocessed Label? . .
	BNE	IN_END6		. . yes
;
; Added - 28th September 2002 (v 4.17)
;
	TST.W	IF_L(A6)
	BEQ	IN_END7		IFs OK
	MOVEQ	#-18,D1		Too few END_IFs
	SUBQ.L	#1,LINE_NO(A6)
	BSR	DO_ERR		====> Warning
	ADDQ.L	#1,LINE_NO(A6)
;
IN_END7	MOVEQ	#0,D2		set D2.B > 0 for INS_LB3
	BSR	INS_LB3		set PC even
	BSR	ST_LNO		to next line (twice)
	BSR	ST_LNO
	MOVE.L	A5,D0
	ADD.L	D0,([PC_PR,A6])
	MOVE.W	CRT_SEC(A6),([PC_PR,A6],4)
	ADD.L	D0,([PC_TH,A6])
	MOVE.W	CRT_SEC(A6),([PC_TH,A6],4)
	BRA	PASS2
IN_END1	SUBQ.W	#1,CH_NO(A6)	previous IN file
	MOVE.L	CH_IN(A6),D0
	BPL.S	IN_END2		not a MACRO
	BCLR	#31,D0
	MOVEA.L	(A7)+,A6		recall pointer
	UNLK	A6		release parameter space
	MOVE.W	CHM_NO(A6),D7
	SUBQ.W	#1,CHM_NO(A6)
	MOVE.W	([CHM_LST,A6],D7.W*8,-8),D5  MACRO no
	SUBQ.W	#2,D7
	BMI	IN_END5		do CLOSE and release 'P' space
IN_END4	CMP.W	([CHM_LST,A6],D7.W*8),D5 is MACRO still open?
	DBEQ	D7,IN_END4	     .................
	BNE	IN_END2		     .. no
	MOVEQ	#-1,D3
	MOVE.L	([CHM_LST,A6],D7.W*8,4),D1  position of file
	MOVEQ	#FS_POSAB,D0
	TRAP	#3
	BRA	IN_END3		don't CLOSE
;
IN_END6	MOVE.W	#$2020,LBUF(A6)	set instruction . .
	MOVE.L	#$454E440A,2+LBUF(A6)	. . END
	MOVEQ	#6,D1			set count
	BRA	DO_LINE1
;
IN_END5	MOVE.L	D0,D7
	BSR	PR31_PL		pointer to 'P' chain
	MOVEA.L	A0,A1
	MOVEA.L	4(A1),A0		address of MACL area . .
	CLR.L	4(A1)
	MOVE.L	-(A0),D1		. . and its length
	LEA	HEAPAD(A6),A1
	MOVEA.W	MM_LNKFR,A2
	JSR	(A2)
	MOVE.L	D7,D0
IN_END2	MOVEA.L	D0,A0
	MOVEQ	#IO_CLOSE,D0
	TRAP	#2		close current IN file
IN_END3	MOVE.L	([CH_LST,A6],D4.W*4,-4),CH_IN(A6) next CH_IN
	BRA	GLIN1		and assemble it
;
	IN	@TITLE,"_1A_ASM"
	IN	@TITLE,"_2_ASM"
	IN	@TITLE,"_3_ASM"
	IN	@TITLE,"_4_ASM"
	IN	@TITLE,"_5_ASM"
	IN	@TITLE,"_6_ASM"
